<?php
/** * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
require_once('purview.php'); // 后台安全权限文件
require_once('../include/function.php'); // 调用函数库
require_once('../include/uploadfile.class.php'); // 调用上传类
/**
 +-------------------------------------------------------------------
 * 主体处理程序 $act
 +-------------------------------------------------------------------
 * setup  常用配置
 +-------------------------------------------------------------------
 */
$act = empty($_GET['act']) ? 'setup' : $_GET['act'];

switch($act) {


	case 'setup':

		// - 输出编辑列表
		$re1s = $db->query("select * from {$prefix}_setup where id = 1");
		$re1r = $db->getarray($re1s);
		$editlist = smarrayall($re1r);
		$smarty->assign('edit', $editlist); // 定义显示数组

		// - 输出模板列表
		$handle = @opendir('../skins');
		while ($file = @readdir($handle)) {
			if($file!="." and $file!=".." and is_dir("../skins/".$file)==true) {
				$skins_list_array[] = $file;
			}
		}

		$smarty->assign('skins_list', $skins_list_array);
		$smarty->assign('b_skins', $skins); // 当前默认模板 // 当前默认模板

		break;

	case 'setupsave':

		// - 安全检查、变量设置
		$id   = 1;
		$cn   = $_POST['cn']; // 简
		$tk   = $_POST['tk']; // 繁
		$en   = $_POST['en']; // 英
		$html = $_POST['html']; // 编辑器

		$_POST['cn'] = $_POST['cn']==1 ? 1 : 0;
		$_POST['tk'] = $_POST['tk']==1 ? 1 : 0;
		$_POST['en'] = $_POST['en']==1 ? 1 : 0;

		$_SESSION['cn']   = $_POST['cn'];
		$_SESSION['tk']   = $_POST['tk'];
		$_SESSION['en']   = $_POST['en'];
		$_SESSION['html'] = $_POST['html'];

		// - 插入数据表
		$condition = 'id='.$id; // 条件

		// - 设定参数
		$upload = new UploadFile();
		$up = 1; // 上传状态 1 成功 0 失败
		$upload->maxSize  = -1 ; // 设置上传文件大小
		$upload->allowExts  = array('gif', 'jpg', 'png', 'jpeg'); // 设置上传文件类型
		$upload->savePath =  '../upload/system/'; // 设置附件上传目录
		$upload->saveRule =  'create_guid'; // 上传文件命名规则

		// - 执行上传操作
		if (!$upload->upload()) { // 捕获上传异常
			if ($upload->nerror!=4) { // 上传文件如果不为空
				$up = 0; // 上传状态 1 成功 0 失败
			}
		} else {
			$uploadList = $upload->getUploadFileInfo();	// 取得成功上传的文件信息
		}

		if($up == 1) { // 如果上传成功

			$_POST['cn_logo']  = $uploadList['cn_logo'];
			$_POST['tk_logo']  = $uploadList['tk_logo'];
			$_POST['en_logo']  = $uploadList['en_logo'];
			// - 处理图片
			$re1s = $db->query("select cn_logo,tk_logo,en_logo from {$prefix}_setup where id = '$id'");
			$re1r = $db->getarray($re1s);
			if (!empty($_FILES['cn_logo']['name'])) {
				if (!empty($re1r['cn_logo'])) {
					@unlink("../upload/system/".$re1r['cn_logo']);
				}
				$db->update_list("{$prefix}_setup", $_POST, $condition, '|cn_logo');
			}
			if (!empty($_FILES['tk_logo']['name'])) {
				if (!empty($re1r['tk_logo'])) {
					@unlink("../upload/system/".$re1r['tk_logo']);
				}
				$db->update_list("{$prefix}_setup", $_POST, $condition, '|tk_logo');
			}
			if (!empty($_FILES['en_logo']['name'])) {
				if (!empty($re1r['en_logo'])) {
					@unlink("../upload/system/".$re1r['en_logo']);
				}
				$db->update_list("{$prefix}_setup", $_POST, $condition, '|en_logo');
			}
			// - 处理非图片数据
			$db->update_list("{$prefix}_setup", $_POST, $condition, '|cn|tk|en|html|language|rewrite|cn_name|tk_name|en_name|url|skins|cn_key|tk_key|en_key|cn_copyright|tk_copyright|en_copyright|cn_tel|tk_tel|en_tel|cn_fax|tk_fax|en_fax|cn_address|tk_address|en_address|cn_postalcode|tk_postalcode|en_postalcode|cn_email|tk_email|en_email|cn_icp|tk_icp|en_icp|cn_about|tk_about|en_about|cn_other|tk_other|en_other|cache|cache_page');
			$message = '常用配置已经成功,正在返回....!';
		} else {
			$message = $upload->getErrorMsg();
		}

		$jumpurl = 'setup.php?act=setup'; // 成功后跳转回

		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$b_skins.'/zt_messjump.html');
		exit();

		break;

}

/**
 +-------------------------------------------------------------------
 * 调用关于我们文件
 +-------------------------------------------------------------------
 */
// 程序结束时间
$smarty->assign('ptime', ptime($time_start));
$smarty->assign('act', $act);
$smarty->display('skins/'.$b_skins.'/zt_setup.html');
?>