<?php
/**
 * 前台新闻页面主文件 * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
session_start();
require_once('include/config.php'); // 调用配置文件
require_once('include/db_mysql.php'); // 调用数据库类
require_once('include/common.inc.php'); // 调用公共配置文件
require_once('include/smarty_no_con.php'); // 调用smarty文件
require_once('include/function.php'); // 调用基本函数库
require_once('include/page.class.php');         // 调用分页类

require_once('include/include_default.php');    // 调用默认固定标签
require_once('include/include_top.php');        // 调用头部标签
require_once('include/include_ad.php');         // 调用广告标签
require_once('include/include_link.php');       // 调用友情链接标签


/**
 +-------------------------------------------------------------------
 * 主体处理程序 $act
 +-------------------------------------------------------------------
 * reg  注册
 * regsave 注册处理
 * login  验证
 * loginsave 验证处理
 * logout 登出
 * edit 编辑
 * editsave 编辑保存
 +-------------------------------------------------------------------
 */ 

$act = empty($_GET['act']) ? 'login' : $_GET['act'];
$smarty->assign('c_username', $_COOKIE['c_username']); // 用户名
$smarty->assign('c_userid', $_COOKIE['c_userid']); // 密码

switch($act) {

	case 'reg':


		break;

	case 'regsave':


		if (version_compare( phpversion(), "5.0.0", ">=")) {
			include("include/auth/AuthCode.class.php5"); // 调用验证码类
		} else {
			include("include/auth/AuthCode.class.php"); // 调用验证码类
		}

		$auth_code_obj = new AuthCode();
		$validate      = $_POST['validate'];

		if ($auth_code_obj->validate($validate, false)) {

			// 判断是否存在相同的用户名
			$username = $_POST['username'];
			$re2s = $db->query("select * from {$prefix}_members where username='$username'");
			$re2r = $db->getarray($re2s);
			if ($re2r) {
				$message = '该用户名已经被使用，正在返回..';
				$jumpurl = 'member.php?act=reg'; // 跳转链接，默认返回
			} else {

				// - 参数设置

				$_POST['regdate']  = time();
				$_POST['regip']    = getip();
				$_POST['password'] = md5($_POST['password']);
				$_POST['groupid']  = 4; // 注册用户

				// - 插入数据表
				$db->insert_list("{$prefix}_members", $_POST, '|username|password|gender|adminid|groupid|regip|regdate|lastactivity|lastpost|posts|oltime|pageviews|credits|email|bday|truename|byear|bmonth|idtype|idcard|city|industry|edulevel|occupation|income|telephone|mobile|address|postid|homepage|qq|msn|alipay|avatar|content');
				$message = $username.'已经注册成功,正在返回首页!';
				$jumpurl = 'index.php'; // 跳转链接，默认返回
			}
		} else {
			$message = '验证码有误，正在返回登陆界面!!!!';
			$jumpurl = 'member.php?act=reg'; // 跳转链接，默认返回
		}

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间

		break;

	case 'login':



		break;

	case 'loginsave':

		$username = $_POST['username'];
		$password = md5($_POST['password']);
		$re1s = $db->query("select uid,username,password,groupid from {$prefix}_members where username='$username' and password='$password'");
		$re1r = $db->getarray($re1s);
		if ($re1r) {
			setcookie('c_username', $re1r['username'], 0, '/');
			setcookie('c_userid', $re1r['uid'], 0, '/');
			setcookie('c_groupid', $re1r['groupid'], 0, '/');			
			if (empty($_GET['url'])) {
				$message = '已经登录成功，正在返回首页!!!!';
				$jumpurl = 'index.php'; // 跳转链接，默认返回
			} else {
				$message = '已经登录成功，正在返回登陆界面!!!!';
				$jumpurl = $_GET['url']; // 跳转链接，默认返回
			}
		} else {
			setcookie('c_username', '', 0, '/');
			setcookie('c_userid', '', 0, '/');
			setcookie('c_groupid', '', 0, '/');			
			if (empty($_GET['url'])) {
				$message = '用户名或密码错误，正在返回登陆界面!!!!';
				$jumpurl = 'member.php?act=login'; // 跳转链接，默认返回
			} else {
				$message = '用户名或密码错误，正在返回登陆界面!!!!';
				$jumpurl = $_GET['url']; // 跳转链接，默认返回
			}
		}

		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url

		break;


	case 'logout':

		setcookie('c_username', '', 0, '/');
		setcookie('c_userid', '', 0, '/');
		setcookie('c_groupid', '', 0, '/');
		
		break;


	case 'edit':

		// - 安全检查、变量设置

		$c_userid  = f_int($_COOKIE['c_userid']);
		if (empty($c_userid)) {
			$smarty->assign('c_userid', $c_userid); // 定义显示url
		} else {
			// - 输出编辑列表
			$re1s = $db->query("select * from {$prefix}_members where uid = '$c_userid'");
			$re1r = $db->getarray($re1s);
			$editlist = smarrayall($re1r);
			$smarty->assign('edit', $editlist); // 定义显示数组

		}

		break;


	case 'editsave':

		// - 安全检查、变量设置
		$uid = $_COOKIE['c_userid']; // 获取用户名
		$jumpurl  = 'member.php?act=edit'; // 跳转链接，默认返回

		$password = md5($_POST['password']);
		$re1s = $db->query("select uid,username,password,groupid from {$prefix}_members where uid='$uid' and password='$password'");
		$re1r = $db->getarray($re1s);

		if (empty($re1r)) {
			$message = '密码不正确，请重新输入...';
		} else {

			// - 设定参数
			$condition    = 'uid='.$uid; // 条件

			// - 处理密码
			if (!empty($_POST['npassword'])) {
				$_POST['password'] = md5($_POST['npassword']);
				$db->update_list("{$prefix}_members", $_POST, $condition, '|password');
			}

			// - 更改其它数据

			// - 编辑数据
			$db->update_list("{$prefix}_members", $_POST, $condition, '|truename|gender|byear|bmonth|bday|postid|telephone|mobile|city|email|address');
			$message = $username.'已经编辑成功,正在返回!';
			$jumpurl = 'member.php?act=edit'; // 成功后跳转回
		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间


		break;

}


/* ***********************************************************
* 调用模板文件
*********************************************************** */
$smarty->assign('act', $act);
$setuplist = smarrayall($setup);
$smarty->assign('setup', $setuplist); // 定义显示数组
$smarty->assign('ptime', ptime($time_start)); // 程序结束时间
$smarty->assign('c_userid', $c_userid); // Cookie userid
$smarty->assign('c_username', $c_username);  // Cookie username
// $smarty->display("skins/".$skins."/zt_member.html");
// 调用相对应的模板文件，$skins是默认风格，$language是默认语言
$smarty->display('skins/'.$skins.'/'.$language.'_member.html');
?>