<?php
// - SESSION安全检测
@session_start();
if (empty($_SESSION['userid'])) {
	exit('您没有权限进入该页面!!!!');
}
require_once('../../include/config.php');
require_once('../../include/db_mysql.php');
require_once('../../include/common.inc.php');
require_once('../../include/function.php');

// - 用户组安全检测
$re01s = $db->query("select uid,username,password,groupid from {$prefix}_members where uid={$_SESSION['userid']}");
$re01r = $db->getarray($re01s);
$re02s = $db->query("select * from {$prefix}_groups where id={$re01r['groupid']}");
$re02r = $db->getarray($re02s);
if ($re02r['manager']!=1) {
	exit('您没有权限进入后台管理系统!!!!');
}

// - 更高权限的安全认证

$MPID = substr(md5($_SERVER['REMOTE_ADDR'].$_SERVER['HTTP_USER_AGENT'].$safe), 7, 5);
if ($MPID != $_SESSION['MPID']) {
	// 如果正常情况下出现以下警告语句，请将下行注释或者删除
	exit('警告!你的资料已被系统记录，请务非法进入系统!!!!');
}

ini_set("max_execution_time","180");
$presql_setup = $prefix."_setup";
$re1s = $db->query("SELECT * FROM $presql_setup where id=1");
$re1r = $db->getarray($re1s);
$skins = $re1r['skins'];
function write_file($sql,$filename)
{
	$re=true;
	if(!@$fp=fopen("./backup/".$filename,"w+")) {$re=false; echo "failed to open target file";}
	if(!@fwrite($fp,$sql)) {$re=false; echo "failed to write file";}
	if(!@fclose($fp)) {$re=false; echo "failed to close target file";}
	return $re;
}

function down_file($sql,$filename)
{
	ob_end_clean();
	header("Content-Encoding: none");
	header("Content-Type: ".(strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') ? 'application/octetstream' : 'application/octet-stream'));

	header("Content-Disposition: ".(strpos($_SERVER['HTTP_USER_AGENT'], 'MSIE') ? 'inline; ' : 'attachment; ')."filename=".$filename);

	header("Content-Length: ".strlen($sql));
	header("Pragma: no-cache");

	header("Expires: 0");
	echo $sql;
	$e=ob_get_contents();
	ob_end_clean();
}

function writeable($dir)
{

	if(!is_dir($dir)) {
		//@mkdir($dir, 0777);
	}

	if(is_dir($dir))
	{

		if($fp = @fopen("$dir/test.test", 'w'))
		{
			@fclose($fp);
			@unlink("$dir/test.test");
			$writeable = 1;
		}
		else {
			$writeable = 0;
		}

	}

	return $writeable;

}

function make_header($table)
{global $d;
$sql="DROP TABLE IF EXISTS ".$table."\n";
$d->query("show create table ".$table);
$d->nextrecord();
$tmp=preg_replace("/\n/","",$d->f("Create Table"));
$sql.=$tmp."\n";
return $sql;
}

function make_record_skins($table,$num_fields)
{global $d;
$comma="";
$sql .= "INSERT INTO ".$table." VALUES('',";
for($i = 1; $i < $num_fields; $i++) {
	$sql .= ($comma."'".mysql_escape_string($d->record[$i])."'"); $comma = ",";
}
$sql .= ")\n";
return $sql;
}

function make_record($table,$num_fields)
{global $d;
$comma="";
$sql .= "INSERT INTO ".$table." VALUES(";
for($i = 0; $i < $num_fields; $i++)
{$sql .= ($comma."'".mysql_escape_string($d->record[$i])."'"); $comma = ",";}
$sql .= ")\n";
return $sql;
}

function show_msg($msgs)
{
	//$title="备份提示：";
	//echo "<table width='100%' border='1'  cellpadding='0' cellspacing='1'>";
	//echo "<tr><td>".$title."</td></tr>";
	//echo "<tr><td><br><ul>";
	echo "<META http-equiv=Content-Type content='text/html; charset=UTF-8'>";
	echo "<link href='../skins/default/images/css.css' rel='stylesheet' type='text/css' />";
	echo "<table width='96%' border='0' align='center' cellpadding='0' cellspacing='0'>";
	echo "<tr><td width='100%' height='20'><table align='center' bgcolor='#c4c4c4' border='0' cellpadding='0' cellspacing='0' width='100%'><tr>";
	echo "<td><table border='0' cellpadding='4' cellspacing='1' width='100%'><tr id='cat'>";
	echo "<td width='100%' height='25' valign='bottom' background='../skins/default/images/cat.gif' bgcolor='#f1f1f1' class='txt'><font color='#A87E00'><img src='../skins/default/images/mac.gif' width='10' height='10' align='absmiddle' /></font> 备份提示</td></tr>";
	echo "<tr align='middle'><td align='middle' background='../skins/default/images/bg.gif' bgcolor='#ffffff'><table width='100%'  border='0' cellpadding='0' cellspacing='1'>";
	echo "<tr><td height='5'></td></tr><tr><td height='30'><div align='left' class='txt'><ul>";
	while (list($k,$v)=each($msgs))
	{
		echo "<li>".$v."</li>";
	}

	echo "</ul></div></td></tr><tr><td height='2' bgcolor='#F2F2F2'></td></tr></table></td></tr></table></td></tr></table></td></tr></table>";
	//echo "</ul></td></tr></table>";
}

function pageend()
{
	exit();
}
if($_SESSION['groupid']==1 or $_SESSION['groupid']==2){
	global $mysqlhost, $mysqluser, $mysqlpwd, $mysqldb;
	$mysqlhost=$db_hostname; //host name
	$mysqluser=$db_username;              //login name
	$mysqlpwd=$db_password;              //password
	$mysqldb=$db_database;        //name of database
	class db{
		var $linkid;
		var $sqlid;
		var $record;
		function db($host="",$username="",$password="",$database=""){
			if(!$this->linkid)  @$this->linkid = mysql_connect($host, $username, $password) or die("连接服务器失败.");
			@mysql_select_db($database,$this->linkid) or die("无法打开数据库");
			return $this->linkid;
		}
		function query($sql){
			if($this->sqlid=mysql_query($sql,$this->linkid)) return $this->sqlid;
			else {
				$this->err_report($sql,mysql_error);
				return false;
			}
		}
		function nr($sql_id=""){
			if(!$sql_id) $sql_id=$this->sqlid;
			return mysql_num_rows($sql_id);
		}
		function nf($sql_id=""){
			if(!$sql_id) $sql_id=$this->sqlid;
			return mysql_num_fields($sql_id);
		}
		function nextrecord($sql_id=""){
			if(!$sql_id) $sql_id=$this->sqlid;
			if($this->record=mysql_fetch_array($sql_id))  return $this->record;
			else return false;
		}
		function f($name){
			if($this->record[$name]) return $this->record[$name];
			else return false;
		}
		function close() {mysql_close($this->linkid);}
		function lock($tblname,$op="WRITE")
		{if(mysql_query("lock tables ".$tblname." ".$op)) return true; else return false;}
		function unlock()
		{if(mysql_query("unlock tables")) return true; else return false;}
		function ar() {
			return @mysql_affected_rows($this->linkid);
		}
		function i_id() {
			return mysql_insert_id();
		}
		function err_report($sql,$err){
			echo "Mysql查询错误<br>";
			echo "查询语句：".$sql."<br>";
			echo "错误信息：".$err;
		}
		/****************************************类结束***************************/
	}
	$d=new db($mysqlhost,$mysqluser,$mysqlpwd,$mysqldb);
	/*--------------界面--------------*/if(!$_POST['act']){/*----------------------*/
	?>
	<META http-equiv=Content-Type content="text/html; charset=UTF-8">
	<link href="../skins/default/images/css.css" rel="stylesheet" type="text/css" />
	<table width="100%" border="0" cellspacing="0" cellpadding="0">
	  <tr>
		<td height="6"></td>
	  </tr>
	  <tr>
		<td>
		
		<table width="96%"  border="0" align="center" cellpadding="0" cellspacing="0">
		  <tr>
			<td width="100%" height="20"><table align="center" bgcolor="#c4c4c4" border="0" cellpadding="0" cellspacing="0" width="100%">
				<tr>
				  <td><table border="0" cellpadding="4" cellspacing="1" width="100%">
					  <tr id="cat">
						<td width="100%" height="25" valign="bottom" background="../skins/default/images/cat.gif" bgcolor="#f1f1f1" class="txt"><font color="#A87E00"><img src="../skins/default/images/mac.gif" width="10" height="10" align="absmiddle" /></font> 备份提示</td>
					  </tr>
					  <tr align="middle">
						<td align="middle" background="../skins/default/images/bg.gif" bgcolor="#ffffff"><table width="100%"  border="0" cellpadding="0" cellspacing="1">
						  <tr>
							<td height="5"></td>
						  </tr>
						  <tr>
							<td height="30"><div align="left" class="txt">
								<ul>
								  <li>服务器备份目录为/adminc/sql/backup，请保证该目录可读写,Linux服务器权限设为0777</li>
								  <li>对于较大的数据表，强烈建议使用分卷备份</li>
								  <li>只有选择备份到服务器，才能使用分卷备份功能</li>
								</ul>
							</div></td>
						  </tr>
						  <tr>
							<td height="2" bgcolor="#F2F2F2"></td>
						  </tr>
						</table></td>
					  </tr>
				  </table></td>
				</tr>
			</table></td>
		  </tr>
		</table>
		
		  <table width="96%"  border="0" align="center" cellpadding="0" cellspacing="0">
			<tr>
			  <td height="16" class="a">&nbsp;</td>
			</tr>
			<tr>
			  <td height="16" class="a">&nbsp;</td>
			</tr>
		  </table>    
		  <table width="96%"  border="0" align="center" cellpadding="0" cellspacing="0">
			<tr>
			  <td width="100%" height="20"><table align="center" bgcolor="#c4c4c4" border="0" cellpadding="0" cellspacing="0" width="100%">
				  <tr>
					<td><table border="0" cellpadding="4" cellspacing="1" width="100%">
						<tr id="cat">
						  <td width="100%" height="25" valign="bottom" background="../skins/default/images/cat.gif" bgcolor="#f1f1f1" class="txt"><font color="#A87E00"><img src="../skins/default/images/mac.gif" width="10" height="10" align="absmiddle" /></font> 数据备份</td>
						</tr>
						<tr align="middle">
						  <td align="middle" background="../skins/default/images/bg.gif" bgcolor="#ffffff"><table width="100%"  border="0" cellpadding="0" cellspacing="1">
							  <tr>
								<td height="5"></td>
							  </tr>
							  <tr>
								<td height="30"><div align="left" class="txt">
								  <form name="form1" method="post" action="backup.php">
	  <table width="96%" border="0" align="center" cellpadding="0" cellspacing="0">
		<tr>
		  <td bgcolor="#CCCCCC"><table width="100%" border="0" align="center" cellpadding='0' cellspacing='1' class="txt">
			<tr>
			  <td height="25" colspan="2" bgcolor="#FFFFFF">备份方式</td>
			</tr>
			<tr>
			  <td height="25" bgcolor="#FFFFFF"><input type="radio" name="bfzl" value="quanbubiao" />
备份全部数据  
  <input name="bf_user" type="checkbox" id="bf_user" value="1" />
  user用户表除外</td>
			  <td height="25" bgcolor="#FFFFFF">备份全部数据表中的数据到一个备份文件</td>
			  </tr>
			<tr>
			  <td height="30" bgcolor="#FFFFFF"><input type="radio" name="bfzl" value="skins" />
备份风格模板相关数据</td>
			  <td height="25" bgcolor="#FFFFFF"><font color="#FF0000">备份当前模板风格数据(恢复时会删除相应模板现有的数据)<br />
			     <font color="#0000FF">主要备份当前风格的顶部菜单、广告及相应的标签</font></font></td>
			</tr>
			<tr>
			  <td height="25" bgcolor="#FFFFFF"><input type="radio" name="bfzl" value="danbiao" />
				备份单张表数据
				<select name="tablename" class="fmInput">
				  <option value="">请选择</option>
					<?
					$d->query("show table status from $mysqldb");
					while($d->nextrecord()){
						echo "<option value='".$d->f('Name')."'>".$d->f('Name')."</option>";}
			?>
				</select></td>
			  <td height="25" bgcolor="#FFFFFF">备份选中数据表中的数据到单独的备份文件</td>
			</tr>
			<tr>
			  <td height="25" colspan="2" bgcolor="#FFFFFF">使用分卷备份</td>
			</tr>
			<tr>
			  <td height="25" colspan="2" bgcolor="#FFFFFF"><input type="checkbox" name="fenjuan" value="yes" />
				分卷备份
				<input name="filesize" type="text" class="fmInput" size="10" />
				K</td>
			</tr>
			<tr>
			  <td height="25" colspan="2" bgcolor="#FFFFFF">选择目标位置</td>
			</tr>
			<tr>
			  <td height="25" colspan="2" bgcolor="#FFFFFF"><input type="radio" name="weizhi" value="server" checked="checked" />
				备份到服务器</td>
			</tr>
			<tr class="cells">
			  <td height="25" colspan='2' bgcolor="#FFFFFF"><input type="radio" name="weizhi" value="localpc" />
				备份到本地</td>
			</tr>
			<tr>
			  <td height="25" colspan="2" align='center' bgcolor="#FFFFFF"><input name="act" type="submit" class="fmButton" value="备份" /></td>
			</tr>
		  </table></td>
		</tr>
	  </table>
								  </form>
								</div></td>
							  </tr>
							  <tr>
								<td height="2" bgcolor="#F2F2F2"></td>
							  </tr>
						  </table></td>
						</tr>
					</table></td>
				  </tr>
			  </table></td>
			</tr>
		  </table></td>
	  </tr>
	  <tr>
		<td>&nbsp;</td>
	  </tr>
	</table>
	
	<?
	/*-------------界面结束-------------*/}/*---------------------------------*/
	/*----*/else{/*--------------主程序-----------------------------------------*/
		if($_POST['weizhi']=="localpc"&&$_POST['fenjuan']=='yes')
		{$msgs[]="只有选择备份到服务器，才能使用分卷备份功能";
		show_msg($msgs); pageend();}
		if($_POST['fenjuan']=="yes"&&!$_POST['filesize'])
		{$msgs[]="您选择了分卷备份功能，但未填写分卷文件大小";
		show_msg($msgs); pageend();}
		if($_POST['weizhi']=="server"&&!writeable("./backup"))
		{$msgs[]="备份文件存放目录'./backup'不可写，请修改目录属性";
		show_msg($msgs); pageend();}

		/*----------备份全部表-------------*/if($_POST['bfzl']=="quanbubiao"){/*----*/
			/*----不分卷*/if(!$_POST['fenjuan']){/*--------------------------------*/
				if(!$tables=$d->query("show table status from $mysqldb"))
				{$msgs[]="读数据库结构错误"; show_msg($msgs); pageend();}
				$sql="";
				while($d->nextrecord($tables))
				{
					$table=$d->f("Name");
					$table_no = $prefix."_members";
					if($_POST['bf_user']==1 and $table == $table_no) {
					}else {
						$sql.=make_header($table);
						$d->query("select * from $table");
						$num_fields=$d->nf();
						while($d->nextrecord())
						{$sql.=make_record($table,$num_fields);}
					}
				}
				$filename=date("Ymd",time())."_all.sql";
				if($_POST['weizhi']=="localpc") down_file($sql,$filename);
				elseif($_POST['weizhi']=="server")
				{if(write_file($sql,$filename))
				$msgs[]="全部数据表数据备份完成,生成备份文件'./backup/$filename'";
				else $msgs[]="备份全部数据表失败";
				show_msg($msgs);
				pageend();
				}
				/*-----------------不要卷结束*/}/*-----------------------*/
				/*-----------------分卷*/else{/*-------------------------*/
					if(!$_POST['filesize'])
					{$msgs[]="请填写备份文件分卷大小"; show_msg($msgs);pageend();}
					if(!$tables=$d->query("show table status from $mysqldb"))
					{$msgs[]="读数据库结构错误"; show_msg($msgs); pageend();}
					$sql=""; $p=1;
					$filename=date("Ymd",time())."_all";
					while($d->nextrecord($tables))
					{
						$table=$d->f("Name");
						$table_no = $prefix."_members";
						if($_POST['bf_user']==1 and $table == $table_no) {
						}else {
							$table=$d->f("Name");
							$sql.=make_header($table);
							$d->query("select * from $table");
							$num_fields=$d->nf();
							while($d->nextrecord())
							{$sql.=make_record($table,$num_fields);
							if(strlen($sql)>=$_POST['filesize']*1000){
								$filename.=("_v".$p.".sql");
								if(write_file($sql,$filename))
								$msgs[]="全部数据表-卷-".$p."-数据备份完成,生成备份文件'./backup/$filename'";
								else $msgs[]="备份表-".$_POST['tablename']."-失败";
								$p++;
								$filename=date("Ymd",time())."_all";
								$sql="";}
							}
						}
					}
					if($sql!=""){$filename.=("_v".$p.".sql");
					if(write_file($sql,$filename))
					$msgs[]="全部数据表-卷-".$p."-数据备份完成,生成备份文件'./backup/$filename'";}
					show_msg($msgs);
					/*---------------------分卷结束*/}/*--------------------------------------*/
					/*--------备份全部表结束*/}/*---------------------------------------------*/

					/*--------备份模板表------*/elseif($_POST['bfzl']=="skins"){/*------------*/
						/*----不分卷*/if(!$_POST['fenjuan']){/*--------------------------------*/
							//if(!$_POST['tablename'])
							//	{$msgs[]="请选择要备份的数据表"; show_msg($msgs); pageend();}
							/*--------不分卷*//*-------------------------------*/
							if(!$_POST['fenjuan']) {

								//$skins = "default";		// 风格


								$tablename1 = $prefix."_ad";
								$tablename2 = $prefix."_menu";
								$tablename3 = $prefix."_article_dir_include";
								$tablename4 = $prefix."_article_include";
								$tablename5 = $prefix."_case_dir_include";
								$tablename6 = $prefix."_case_include ";
								$tablename7 = $prefix."_about_include";
								$tablename8 = $prefix."_contact_include";
								$tablename9 = $prefix."_down_dir_include";
								$tablename10 = $prefix."_down_include";
								$tablename11 = $prefix."_link_include";
								$tablename12 = $prefix."_news_dir_include";
								$tablename13 = $prefix."_news_include";
								$tablename14 = $prefix."_person_include";
								$tablename15 = $prefix."_product_dir_include";
								$tablename16 = $prefix."_product_include";
								$tablename17 = $prefix."_resource_dir_include";
								$tablename18 = $prefix."_resource_include";
								$tablename19 = $prefix."_service_include";
								$tablename20 = $prefix."_blog_logs_dir_include";
								$tablename21 = $prefix."_blog_logs_include";
								$tablename22 = $prefix."_mpb_dir_include";
								$tablename23 = $prefix."_mpb_include";
								$tablename24 = $prefix."_photo_dir_include";
								$tablename25 = $prefix."_photo_include";

								//$sql=make_header($tablename);
								$sql1 = "DELETE FROM ".$tablename1." WHERE skins='".$skins."';\n";
								$sql2 = "DELETE FROM ".$tablename2." WHERE skins='".$skins."';\n";
								$sql3 = "DELETE FROM ".$tablename3." WHERE skins='".$skins."';\n";
								$sql4 = "DELETE FROM ".$tablename4." WHERE skins='".$skins."';\n";
								$sql5 = "DELETE FROM ".$tablename5." WHERE skins='".$skins."';\n";
								$sql6 = "DELETE FROM ".$tablename6." WHERE skins='".$skins."';\n";
								$sql7 = "DELETE FROM ".$tablename7." WHERE skins='".$skins."';\n";
								$sql8 = "DELETE FROM ".$tablename8." WHERE skins='".$skins."';\n";
								$sql9 = "DELETE FROM ".$tablename9." WHERE skins='".$skins."';\n";
								$sql10 = "DELETE FROM ".$tablename10." WHERE skins='".$skins."';\n";
								$sql11 = "DELETE FROM ".$tablename11." WHERE skins='".$skins."';\n";
								$sql12 = "DELETE FROM ".$tablename12." WHERE skins='".$skins."';\n";
								$sql13 = "DELETE FROM ".$tablename13." WHERE skins='".$skins."';\n";
								$sql14 = "DELETE FROM ".$tablename14." WHERE skins='".$skins."';\n";
								$sql15 = "DELETE FROM ".$tablename15." WHERE skins='".$skins."';\n";
								$sql16 = "DELETE FROM ".$tablename16." WHERE skins='".$skins."';\n";
								$sql17 = "DELETE FROM ".$tablename17." WHERE skins='".$skins."';\n";
								$sql18 = "DELETE FROM ".$tablename18." WHERE skins='".$skins."';\n";
								$sql19 = "DELETE FROM ".$tablename19." WHERE skins='".$skins."';\n";
								$sql20 = "DELETE FROM ".$tablename20." WHERE skins='".$skins."';\n";
								$sql21 = "DELETE FROM ".$tablename21." WHERE skins='".$skins."';\n";
								$sql22 = "DELETE FROM ".$tablename22." WHERE skins='".$skins."';\n";
								$sql23 = "DELETE FROM ".$tablename23." WHERE skins='".$skins."';\n";
								$sql24 = "DELETE FROM ".$tablename24." WHERE skins='".$skins."';\n";
								$sql25 = "DELETE FROM ".$tablename25." WHERE skins='".$skins."';\n";

								// cms_ad
								$d->query("select * from ".$tablename1." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql1.=make_record_skins($tablename1,$num_fields);
								}

								// cms_menu
								$d->query("select * from ".$tablename2." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql2.=make_record_skins($tablename2,$num_fields);
								}

								// cms_include_a_dir
								$d->query("select * from ".$tablename3." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql3.=make_record_skins($tablename3,$num_fields);
								}

								// cms_include_article
								$d->query("select * from ".$tablename4." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql4.=make_record_skins($tablename4,$num_fields);
								}

								// cms_include_d_dir
								$d->query("select * from ".$tablename5." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql5.=make_record_skins($tablename5,$num_fields);
								}

								// cms_include_down
								$d->query("select * from ".$tablename6." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql6.=make_record_skins($tablename6,$num_fields);
								}

								// cms_include_other
								$d->query("select * from ".$tablename7." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql7.=make_record_skins($tablename7,$num_fields);
								}

								// cms_include_other_dir
								$d->query("select * from ".$tablename8." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql8.=make_record_skins($tablename8,$num_fields);
								}


								$d->query("select * from ".$tablename9." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql9.=make_record_skins($tablename9,$num_fields);
								}

								$d->query("select * from ".$tablename10." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql10.=make_record_skins($tablename10,$num_fields);
								}

								$d->query("select * from ".$tablename11." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql11.=make_record_skins($tablename11,$num_fields);
								}

								$d->query("select * from ".$tablename12." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql12.=make_record_skins($tablename12,$num_fields);
								}

								$d->query("select * from ".$tablename13." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql13.=make_record_skins($tablename13,$num_fields);
								}

								$d->query("select * from ".$tablename14." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql14.=make_record_skins($tablename14,$num_fields);
								}

								$d->query("select * from ".$tablename15." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql15.=make_record_skins($tablename15,$num_fields);
								}

								$d->query("select * from ".$tablename16." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql16.=make_record_skins($tablename16,$num_fields);
								}

								$d->query("select * from ".$tablename17." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql17.=make_record_skins($tablename17,$num_fields);
								}

								$d->query("select * from ".$tablename18." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql18.=make_record_skins($tablename18,$num_fields);
								}

								$d->query("select * from ".$tablename19." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql19.=make_record_skins($tablename19,$num_fields);
								}

								$d->query("select * from ".$tablename20." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql20.=make_record_skins($tablename20,$num_fields);
								}

								$d->query("select * from ".$tablename21." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql21.=make_record_skins($tablename21,$num_fields);
								}

								$d->query("select * from ".$tablename22." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql22.=make_record_skins($tablename22,$num_fields);
								}

								$d->query("select * from ".$tablename23." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql23.=make_record_skins($tablename23,$num_fields);
								}

								$d->query("select * from ".$tablename24." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql24.=make_record_skins($tablename24,$num_fields);
								}

								$d->query("select * from ".$tablename25." where skins='".$skins."'");
								$num_fields=$d->nf();
								while($d->nextrecord()) {
									$sql25.=make_record_skins($tablename25,$num_fields);
								}


								// 获取sql语句
								$sql=$sql1.$sql2.$sql3.$sql4.$sql5.$sql6.$sql7.$sql8.$sql9.$sql10.$sql11.$sql12.$sql13.$sql14.$sql15.$sql16.$sql17.$sql18.$sql19.$sql20.$sql21.$sql22.$sql23.$sql24.$sql25;
								$filename=date("Ymd",time())."_skins.sql";

								if($_POST['weizhi']=="localpc") {
									down_file($sql,$filename);
								}elseif($_POST['weizhi']=="server") {
									if(write_file($sql,$filename)) {
										$msgs[]="模板相关表-数据备份完成,生成备份文件'./backup/$filename'";
									}else {
										$msgs[]="备份模板相关表-失败";
									}
									show_msg($msgs);
									pageend();
								}
							}
							/*-----------------不要卷结束*//*-----------------------*/
							/*-----------------分卷*/else{/*-------------------------*/
								//不支持分卷
								/*----------分卷结束*/}/*--------------------------------------------------*/
								/*----------备份模板表结束*/}/*----------------------------------------------*/

								/*---*/}/*-------------备份模板相关表结束------------------------------------------*/


								/*--------备份单表------*/elseif($_POST['bfzl']=="danbiao"){/*------------*/
									if(!$_POST['tablename'])
									{$msgs[]="请选择要备份的数据表"; show_msg($msgs); pageend();}
									/*--------不分卷*/if(!$_POST['fenjuan']){/*-------------------------------*/
										$sql=make_header($_POST['tablename']);
										$d->query("select * from ".$_POST['tablename']);
										$num_fields=$d->nf();
										while($d->nextrecord())
										{$sql.=make_record($_POST['tablename'],$num_fields);}
										$filename=date("Ymd",time())."_".$_POST['tablename'].".sql";
										if($_POST['weizhi']=="localpc") down_file($sql,$filename);
										elseif($_POST['weizhi']=="server")
										{if(write_file($sql,$filename))
										$msgs[]="表-".$_POST['tablename']."-数据备份完成,生成备份文件'./backup/$filename'";
										else $msgs[]="备份表-".$_POST['tablename']."-失败";
										show_msg($msgs);
										pageend();
										}
										/*----------------不要卷结束*/}/*------------------------------------*/
										/*----------------分卷*/else{/*--------------------------------------*/
											if(!$_POST['filesize'])
											{$msgs[]="请填写备份文件分卷大小"; show_msg($msgs);pageend();}
											$sql=make_header($_POST['tablename']); $p=1;
											$filename=date("Ymd",time())."_".$_POST['tablename'];
											$d->query("select * from ".$_POST['tablename']);
											$num_fields=$d->nf();
											while ($d->nextrecord())
											{
												$sql.=make_record($_POST['tablename'],$num_fields);
												if(strlen($sql)>=$_POST['filesize']*1000){
													$filename.=("_v".$p.".sql");
													if(write_file($sql,$filename))
													$msgs[]="表-".$_POST['tablename']."-卷-".$p."-数据备份完成,生成备份文件'./backup/$filename'";
													else $msgs[]="备份表-".$_POST['tablename']."-失败";
													$p++;
													$filename=date("Ymd",time())."_".$_POST['tablename'];
													$sql="";}
											}
											if($sql!=""){$filename.=("_v".$p.".sql");
											if(write_file($sql,$filename))
											$msgs[]="表-".$_POST['tablename']."-卷-".$p."-数据备份完成,生成备份文件'./backup/$filename'";}
											show_msg($msgs);
											/*----------分卷结束*/}/*--------------------------------------------------*/
											/*----------备份单表结束*/}/*----------------------------------------------*/

											/*---*/}/*-------------主程序结束------------------------------------------*/

}
?>