<?php
/**
 * 前台文章页面主文件 * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
require_once('include/config.php'); // 调用配置文件
require_once('include/db_mysql.php'); // 调用数据库类
require_once('include/common.inc.php'); // 调用公共配置文件
require_once('include/smarty_con.php'); // 调用smarty文件
require_once('include/function.php'); // 调用基本函数库
require_once('include/page.class.php'); // 调用分页类

require_once('include/include_default.php');    // 调用默认固定标签
require_once('include/include_top.php'); // 调用头部标签
require_once('include/include_article.php'); // 调用文章标签
require_once('include/include_ad.php'); // 调用广告标签
require_once('include/include_link.php');       // 调用友情链接标签

/**
 +-------------------------------------------------------------------
 * 主体处理程序
 +-------------------------------------------------------------------
 */ 

$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':



		break;

	case 'ser':

		$perpage = empty($_GET['pe']) ? 20 : $_GET['pe']; // 每页显示记录条数
		$page    = empty($_GET['page']) ? 1 : $_GET['page']; // 当页页数
		$pbegin  = ($page * $perpage - $perpage) < 0 ? 0 : $page * $perpage - $perpage; // 起始数据

		$keyword   = mysql_real_escape_string($_REQUEST['keyword']); // 关键字转义
		$condition = mysql_real_escape_string($_REQUEST['condition']); // 转义

		$condition = ($condition == 'cn_title' or $condition == 'cn_content' or $condition == 'tk_title' or $condition == 'tk_content' or $condition == 'en_title' or $condition == 'en_content' or $condition == 'cn_author' or $condition == 'tk_author' or $condition == 'en_author' or $condition == 'cn_editor' or $condition == 'tk_editor' or $condition == 'en_editor') ?  $condition : 'cn_title';

		$tal     = $db->getarray($db->query("select COUNT(*) as total from {$prefix}_article where $condition LIKE '%".$keyword."%'")); // 总记录条数
		$total   = $tal['total'];
		
		$article_ser_array = '';		
		$re1s = $db->query("select * from {$prefix}_article where $condition LIKE '%".$keyword."%' order by compositor asc,time desc limit $pbegin, $perpage");
		while($re1r = $db->getarray($re1s)) {
			$re1r['time_year'] = date("Y-m-d H:i:s", $re1r['time']);
			$re1r['time_y'] = date("Y", $re1r['time']);
			$re1r['time_m'] = date("m", $re1r['time']);
			$re1r['time_d'] = date("d", $re1r['time']);
			$re1r['time_h'] = date("H", $re1r['time']);
			$re1r['time_i'] = date("i", $re1r['time']);
			$re1r['time_s'] = date("s", $re1r['time']);
			$did  = $re1r['did'];
			$re2s = $db->query("select * from {$prefix}_article_dir where id='$did'");
			$re2r = $db->getarray($re2s);
			$re1r['d_cn_title'] = $re2r['cn_title'];
			$re1r['d_tk_title'] = $re2r['tk_title'];
			$re1r['d_en_title'] = $re2r['en_title'];
			$article_ser_array[] = smarrayall($re1r);
		}

		$smarty->assign('artilce_ser', $article_ser_array);

		// - 分页

		$fpage = new page(array('total'=>$total, 'perpage'=>$perpage)); // 调用分页
		$smarty->assign('page', $fpage->show(70)); // 输出分页
		$smarty->assign('url', base64_encode($fpage->_get_url($page))); // 记住url，以便返回

		break;

	case 'page':


		break;

}
/* ***********************************************************
* 调用模板文件
*********************************************************** */
$smarty->assign('act', $act);
$setuplist = smarrayall($setup);
$smarty->assign('setup', $setuplist); // 定义显示数组
$smarty->assign('ptime', ptime($time_start)); // 程序结束时间
$smarty->assign('c_userid', $c_userid); // Cookie userid
$smarty->assign('c_username', $c_username);  // Cookie username
$smarty->display('skins/'.$skins.'/cn_articles_list.html', cache_id('articles_list.php'));
?>