<?php
/**
 * 前台案例页面主文件 * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
require_once('include/config.php'); // 调用配置文件
require_once('include/db_mysql.php'); // 调用数据库类
require_once('include/common.inc.php'); // 调用公共配置文件
require_once('include/smarty_con.php'); // 调用smarty文件
require_once('include/function.php'); // 调用基本函数库
require_once('include/page.class.php'); // 调用分页类

require_once('include/include_default.php');    // 调用默认固定标签
require_once('include/include_top.php');        // 调用头部标签
//require_once('include/include_about.php');      // 调用关于我们标签
require_once('include/include_ad.php');         // 调用广告标签
//require_once('include/include_article.php');    // 调用文章标签
require_once('include/include_case.php');       // 调用项目标签
//require_once('include/include_contact.php');    // 调用联系我们标签
//require_once('include/include_down.php');       // 调用下载标签
require_once('include/include_link.php');       // 调用友情链接标签
//require_once('include/include_news.php');       // 调用新闻标签
//require_once('include/include_person.php');     // 调用诚聘英才标签
//require_once('include/include_product.php');    // 调用产品标签
//require_once('include/include_resource.php');   // 调用资源标签
//require_once('include/include_service.php');    // 调用客户服务标签
//require_once('include/include_vote.php');       // 调用投票标签
//require_once('include/include_blog.php');       // 调用博客标签



/**
 +-------------------------------------------------------------------
 * 主体处理程序
 +-------------------------------------------------------------------
 */ 

$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':

		/**
		 +-------------------------------------------------------------------
		 * 案例前台调用参数
		 +-------------------------------------------------------------------
		 * ID  数据列表
		 * ID: <!--{$view.id}-->		
		 * 中文标题: <!--{$view.cn_title}-->
		 * 繁体标题: <!--{$view.tk_title}-->
		 * 英文标题: <!--{$view.en_title}-->
		 * 外链: <!--{$view.link}-->
		
		 * 排序： <!--{$view.compositor}-->
		 * 是否显示： <!--{$view.available}--> // 1 显示 0 不显示	
		 * 中文内容： <!--{$view.cn_content}-->
		 * 繁体内容： <!--{$view.tk_content}-->
		 * 英文内容： <!--{$view.en_content}-->
		 +-------------------------------------------------------------------
		 */


		// - 安全检查
		//		$id = f_int($_GET['id']);
		//
		//
		//		// - 输出数据列表
		//		$re1s = $db->query("select * from {$prefix}_about where id = '$id'");
		//		$re1r = $db->getarray($re1s);
		//		$viewlist = smarrayall($re1r);
		//		$smarty->assign('view', $viewlist); // 定义显示数组

		break;

	case 'page':

		/**
		 +-------------------------------------------------------------------
		 * 案例前台调用参数
		 +-------------------------------------------------------------------
		 * ID: <!--{$view.id}-->
		 * 目录ID: <!--{$view.did}-->
		 * 简体目录标题: <!--{$view.d_cn_title}-->
		 * 繁体目录标题: <!--{$view.d_tk_title}-->
		 * 英文目录标题: <!--{$view.d_en_title}-->

		 * 中文标题: <!--{$view.cn_title}-->
		 * 繁体标题: <!--{$view.tk_title}-->
		 * 英文标题: <!--{$view.en_title}-->
		 * 外链: <!--{$view.linkurl}-->
		 * 案例图片地址： <!--{$view.pic}--> 

		 * 时间： <!--{$view.time_year}--> // xxxx-xx-xx xx:xx:xx
		 * 年份： <!--{$view.time_y}-->
		 * 月份： <!--{$view.time_m}-->
		 * 日期： <!--{$view.time_d}-->
		 * 小时： <!--{$view.time_h}-->
		 * 分钟： <!--{$view.time_i}-->
		 * 秒钟： <!--{$view.time_s}-->

		 * 排序： <!--{$view.compositor}-->
		 * 是否显示： <!--{$view.available}--> // 1 显示 0 不显示
		 * 点击量： <!--{$view.hits}-->
		 
		 * 客户名称简： <!--{$view.cn_client}-->
		 * 客户名称繁： <!--{$view.tk_client}-->
		 * 客户名称英： <!--{$view.en_client}-->
		 * 客户类型简： <!--{$view.cn_type}-->
		 * 客户类型繁： <!--{$view.tk_type}-->
		 * 客户类型英： <!--{$view.en_type}-->

		 * 客户行业简： <!--{$view.cn_calling}-->
		 * 客户行业繁： <!--{$view.tk_calling}-->
		 * 客户行业英： <!--{$view.en_calling}-->

		 * 客户网址： <!--{$view.url}-->
		 * 其它信息简： <!--{$view.cn_other}-->
		 * 其它信息繁： <!--{$view.tk_other}-->
		 * 其它信息英： <!--{$view.en_other}-->

		 * 中文内容： <!--{$view.cn_bewrite}-->
		 * 繁体内容： <!--{$view.tk_bewrite}-->
		 * 英文内容： <!--{$view.en_bewrite}-->
		 * 中文内容： <!--{$view.cn_content}-->
		 * 繁体内容： <!--{$view.tk_content}-->
		 * 英文内容： <!--{$view.en_content}-->

		 +-------------------------------------------------------------------
		 */

		

		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出数据列表
		$re1s = $db->query("select * from {$prefix}_case where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re2s = $db->query("select * from {$prefix}_case_dir where id = '{$re1r['did']}'");
		$re2r = $db->getarray($re2s);
		$re1r['time'] = date("Y-m-d H:i" ,$re1r['time']);
		$re1r['d_cn_title'] = $re1r['cn_title'];
		$re1r['d_tk_title'] = $re1r['tk_title'];
		$re1r['d_en_title'] = $re1r['en_title'];
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组

		// 访问量加1
		$db->update("update {$prefix}_case set hits=hits+1 where id='$id'");

		break;

}


/* ***********************************************************
* 调用模板文件
*********************************************************** */
$smarty->assign('act', $act);
$setuplist = smarrayall($setup);
$smarty->assign('setup', $setuplist); // 定义显示数组
$smarty->assign('ptime', ptime($time_start)); // 程序结束时间
$smarty->assign('c_userid', $c_userid); // Cookie userid
$smarty->assign('c_username', $c_username);  // Cookie username
// 调用相对应的模板文件，$skins是默认风格，$language是默认语言
$smarty->display('skins/'.$skins.'/'.$language.'_case.html', cache_id('case.php'));
?>