<?php
/**
 * 前台下载页面主文件 * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
require_once('include/config.php'); // 调用配置文件
require_once('include/db_mysql.php'); // 调用数据库类
require_once('include/common.inc.php'); // 调用公共配置文件
require_once('include/smarty_page_con.php'); // 调用smarty文件
require_once('include/function.php'); // 调用基本函数库
require_once('include/page.class.php'); // 调用分页类

require_once('include/include_default.php');    // 调用默认固定标签
require_once('include/include_top.php');        // 调用头部标签
//require_once('include/include_about.php');      // 调用关于我们标签
require_once('include/include_ad.php');         // 调用广告标签
//require_once('include/include_article.php');    // 调用文章标签
//require_once('include/include_case.php');       // 调用项目标签
//require_once('include/include_contact.php');    // 调用联系我们标签
require_once('include/include_down.php');       // 调用下载标签
require_once('include/include_link.php');       // 调用友情链接标签
//require_once('include/include_news.php');       // 调用新闻标签
//require_once('include/include_person.php');     // 调用诚聘英才标签
//require_once('include/include_product.php');    // 调用产品标签
//require_once('include/include_resource.php');   // 调用资源标签
//require_once('include/include_service.php');    // 调用客户服务标签
//require_once('include/include_vote.php');       // 调用投票标签
//require_once('include/include_blog.php');       // 调用博客标签

/**
 +-------------------------------------------------------------------
 * 主体处理程序
 +-------------------------------------------------------------------
 */ 

$act = empty($_GET['act']) ? 'page' : $_GET['act'];

switch($act) {

	case 'list':



		break;

	case 'page':

		/**
		 +-------------------------------------------------------------------
		 * 下载前台调用参数
		 +-------------------------------------------------------------------
		 * ID  数据列表
		 * ID: <!--{$view.id}-->
		 * 目录ID: <!--{$view.did}-->
		 * 简体目录标题: <!--{$view.d_cn_title}-->
		 * 繁体目录标题: <!--{$view.d_tk_title}-->
		 * 英文目录标题: <!--{$view.d_en_title}-->
		 		 
		 * 审核: <!--{$view.passed}-->// 1 已审 0 未审
		 * news: <!--{$view.newsday}-->// 
		 * news时间: <!--{$view.passed}-->// 1 是 0 否
		 * hot: <!--{$view.hot}-->// 1 是 0 否
		 * 置顶: <!--{$view.ontop}-->// 1 是 0 否
		 * 粗体: <!--{$view.strong}-->// 1 是 0 否
		 * 斜体: <!--{$view.em}-->// 1 是 0 否
		 * 下划线: <!--{$view.underline}-->// 1 是 0 否
				
		 * 标题: <!--{$view.title}-->
		 * 标题颜色: <!--{$view.titlecolor}-->
		 * 关键字: <!--{$view.keyword}-->
		 * 下载图片地址： <!--{$view.picx}--> 

		 * 时间： <!--{$view.time_year}--> // xxxx-xx-xx xx:xx:xx
		 * 年份： <!--{$view.time_y}-->
		 * 月份： <!--{$view.time_m}-->
		 * 日期： <!--{$view.time_d}-->
		 * 小时： <!--{$view.time_h}-->
		 * 分钟： <!--{$view.time_i}-->
		 * 秒钟： <!--{$view.time_s}-->

		 * 下载类型： <!--{$view.softtype}-->
		 * 语言版本： <!--{$view.softlanguage}-->
		 * 程序版本： <!--{$view.opyrighttype}-->
		 * 下载平台： <!--{$view.operatingsystem}-->
		 * 作者/开发商： <!--{$view.author}-->
		 * 作者网站： <!--{$view.linkurl}-->
		 * 演示地址： <!--{$view.demourl}-->
		 * 注册地址： <!--{$view.regurl}-->
		 * 下载来源： <!--{$view.copyfromname}-->

		 * 下载简介： <!--{$view.bewrite}-->
		 * 软件大小： <!--{$view.softsize}-->
		 * 解压密码： <!--{$view.softpass}-->
		 * 下载评分： <!--{$view.stars}-->

		 * 点击量： <!--{$view.hits}-->
		 * 阅读等级： <!--{$view.readlevel}-->
		 * 内容： <!--{$view.content}-->

		 * 调用分页代码：
		 * 简体及默认：<!--{$down_news_page}-->
		 * 繁体：<!--{$down_news_page_tk}-->
		 * 英文：<!--{$down_news_page_en}-->
		 +-------------------------------------------------------------------
		 */


		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出数据列表
		$re1s = $db->query("select * from {$prefix}_down where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re2s = $db->query("select * from {$prefix}_down_dir where id = '{$re1r['did']}'");
		$re2r = $db->getarray($re2s);
		$re1r['time'] = date("Y-m-d H:s" ,$re1r['time']);
		$re1r['d_cn_title'] = $re2r['cn_title'];
		$re1r['d_tk_title'] = $re2r['tk_title'];
		$re1r['d_en_title'] = $re2r['en_title'];
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组

		// 访问量加1
		$db->update("update {$prefix}_down set hits=hits+1 where id='$id'");
		
		// 输出下载链接
		$phu  = explode('$$$', $re1r['downurl']);
		
		$phun = count($phu);
		for($i=0; $i<$phun; $i++) {
			$du['downurl'] = $phu[$i];
			$df = explode('|', $du['downurl']);
			$df['downurl'] = $df[1];
			$df['downpre'] = $df[0];
			$downurl = substr($df['downurl'], 0, 4);
			if ($downurl == "down") {
				$df['dsort'] = 1; // 上传的文件
			} else {
				$df['dsort'] = 0; // 超链接的文件
			}
			$downurl_list_array[] = smarrayall($df);
		}
		$smarty->assign('downurl_list', $downurl_list_array);
		

		break;

}
/* ***********************************************************
* 调用模板文件
*********************************************************** */
$smarty->assign('act', $act);
$setuplist = smarrayall($setup);
$smarty->assign('setup', $setuplist); // 定义显示数组
$smarty->assign('ptime', ptime($time_start)); // 程序结束时间
$smarty->assign('c_userid', $c_userid); // Cookie userid
$smarty->assign('c_username', $c_username);  // Cookie username
$smarty->display('skins/'.$skins.'/'.$language.'_down_page.html', cache_id('down_page.php'));
?>