<?php
/*********************/
/*                   */
/*  Version : 5.1.0  */
/*  Author  : RM     */
/*  Comment : 071223 */
/*                   */
/*********************/

function messjump( $message, $jumpurl, $jumptime = 1 )
{
}

function unhtmlchars( $chars )
{
	$chars = str_replace( ">", "&gt;", $chars );
	$chars = str_replace( "<", "&lt;", $chars );
	$chars = str_replace( "\"", "&quot;", $chars );
	$chars = str_replace( "'", "&acute;", $chars );
	$chars = str_replace( "\"", "&quot;", $chars );
	return $chars;
}

function showshort( $string, $sublen )
{
	if ( strlen( $string ) <= $sublen )
	{
		return $string;
	}
	$s = "";
	$i = 0;
	for ( ;	$i < $sublen;	++$i	)
	{
		if ( 127 < ord( $string[$i] ) )
		{
			$s .= $string[$i].$string[++$i];
		}
		else
		{
			$s .= $string[$i];
		}
	}
	$s .= "..";
	return $s;
}

function cn_substr( $str, $slen, $startdd = 0 )
{
	$restr = "";
	$c = "";
	$str_len = strlen( $str );
	if ( $str_len < $startdd + 1 )
	{
		return "";
	}
	if ( $str_len < $startdd + $slen || $slen == 0 )
	{
		$slen = $str_len - $startdd;
	}
	$enddd = $startdd + $slen - 1;
	$i = 0;
	for ( ;	$i < $str_len;	++$i	)
	{
		if ( $startdd == 0 )
		{
			$restr .= $c;
		}
		else if ( $startdd < $i )
		{
			$restr .= $c;
		}
		if ( 128 < ord( $str[$i] ) )
		{
			$c = $str[$i].$str[$i + 1];
			++$i;
		}
		else
		{
			$c = $str[$i];
		}
		if ( !( $enddd <= $i ) )
		{
			continue;
		}
		if ( $slen < strlen( $restr ) + strlen( $c ) )
		{
			break;
		}
		$restr .= $c;
		break;
	}
	return $restr;
}

function msubstr( &$fStr, $fStart, $fLen, $fCode = "utf-8", $show = "..." )
{
	if ( function_exists( "mb_substr" ) )
	{
		if ( $fLen < mb_strlen( $fStr, $fCode ) )
		{
			return mb_substr( $fStr, $fStart, $fLen, $fCode ).$show;
		}
		return mb_substr( $fStr, $fStart, $fLen, $fCode );
	}
	if ( function_exists( "iconv_substr" ) )
	{
		if ( $fLen < iconv_strlen( $fStr, $fCode ) )
		{
			return iconv_substr( $fStr, $fStart, $fLen, $fCode ).$show;
		}
		return iconv_substr( $fStr, $fStart, $fLen, $fCode );
	}
	$fCode = strtolower( $fCode );
	switch ( $fCode )
	{
	case "utf-8" :
		preg_match_all( "/[\x01-]|[-][-]|[-][-]|[-][-][-]|[-][-][-]|[-][-][-][-]/", $fStr, $ar );
		if ( 3 <= func_num_args( ) )
		{
			if ( $fLen < count( $ar[0] ) )
			{
				return join( "", array_slice( $ar[0], $fStart, $fLen ) ).$show;
			}
			return join( "", array_slice( $ar[0], $fStart, $fLen ) );
		}
		return join( "", array_slice( $ar[0], $fStart ) );
	}
	$fStart *= 2;
	$fLen *= 2;
	$strlen = strlen( $fStr );
	$i = 0;
	for ( ;	$i < $strlen;	++$i	)
	{
		if ( $fStart <= $i && $i < $fStart + $fLen )
		{
			if ( 129 < ord( substr( $fStr, $i, 1 ) ) )
			{
				$tmpstr .= substr( $fStr, $i, 2 );
			}
			else
			{
				$tmpstr .= substr( $fStr, $i, 1 );
			}
		}
		if ( 129 < ord( substr( $fStr, $i, 1 ) ) )
		{
			++$i;
		}
	}
	if ( strlen( $tmpstr ) < $strlen )
	{
		$tmpstr .= $show;
	}
	return $tmpstr;
}

function timed( $nx10 )
{
	$nx10 = $nx10 < 10 ? "0".$nx10 : $nx10;
	return $nx10;
}

function mydelete( $dirn )
{
	if ( file_exists( $dirn ) )
	{
		if ( is_file( $dirn ) )
		{
			@unlink( $dirn );
		}
		else
		{
			$handle = opendir( $dirn );
			while ( $file = readdir( $handle ) )
			{
				if ( $file == "." || $file == ".." )
				{
					if ( is_dir( $dirn."/{$file}" ) )
					{
						mydelete( $dirn."/{$file}" );
					}
					else
					{
						@unlink( $dirn."/{$file}" );
					}
				}
			}
			@closedir( $handle );
			@rmdir( $dirn."/{$file}" );
		}
	}
}

function heighphpcode( $Heightstring )
{
	$Heightstring = highlight_string( $Heightstring, 1 );
	return $Heightstring;
}

function randstring( $length )
{
	$chars = array( "a", "A", "b", "B", "c", "C", "d", "D", "e", "E", "f", "F", "g", "G", "h", "H", "i", "I", "j", "J", "k", "K", "l", "L", "m", "M", "n", "N", "o", "O", "p", "P", "q", "Q", "r", "R", "s", "S", "t", "T", "u", "U", "v", "V", "w", "W", "x", "X", "y", "Y", "z", "Z", "1", "2", "3", "4", "5", "6", "7", "8", "9", "0" );
	$max_chars = count( $chars ) - 1;
	srand( ( double )microtime( ) * 1000000 );
	$rand_str = "";
	$i = 0;
	for ( ;	$i < $length;	++$i	)
	{
		$rand_str = $i == 0 ? $chars[rand( 0, $max_chars )] : $rand_str.$chars[rand( 0, $max_chars )];
	}
	return $rand_str;
}

function create_guid( )
{
	$charid = strtoupper( md5( uniqid( mt_rand( ), true ) ) );
	$hyphen = chr( 45 );
	$uuid = chr( 123 ).substr( $charid, 0, 8 ).$hyphen.substr( $charid, 8, 4 ).$hyphen.substr( $charid, 12, 4 ).$hyphen.substr( $charid, 16, 4 ).$hyphen.substr( $charid, 20, 12 ).chr( 125 );
	return $uuid;
}

function rand_string( $len = 6, $type = "", $addChars = "" )
{
	$str = "";
	switch ( $type )
	{
	case 0 :
		$chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz".$addChars;
		break;
	case 1 :
		$chars = "0123456789";
		break;
	case 2 :
		$chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".$addChars;
		break;
	case 3 :
		$chars = "abcdefghijklmnopqrstuvwxyz".$addChars;
		break;
		$chars = "ABCDEFGHIJKMNPQRSTUVWXYZabcdefghijkmnpqrstuvwxyz23456789".$addChars;
	}
	if ( 10 < $len )
	{
		$chars = $type == 1 ? str_repeat( $chars, $len ) : str_repeat( $chars, 5 );
	}
	$chars = str_shuffle( $chars );
	$str = substr( $chars, 0, $len );
	return $str;
}

function build_count_rand( $number, $length = 4, $mode = 1 )
{
	if ( $mode == 1 && $length < strlen( $number ) )
	{
		return false;
	}
	$rand = array( );
	$i = 0;
	for ( ;	$i < $number;	++$i	)
	{
		$rand[] = rand_string( $length, $mode );
	}
	$unqiue = array_unique( $rand );
	if ( count( $unqiue ) == count( $rand ) )
	{
		return $rand;
	}
	$count = count( $rand ) - count( $unqiue );
	$i = 0;
	for ( ;	$i < $count * 3;	++$i	)
	{
		$rand[] = rand_string( $length, $mode );
	}
	$rand = array_slice( array_unique( $rand ), 0, $number );
	return $rand;
}

function rand_number( $min, $max )
{
	return sprintf( "%0".strlen( $max )."d", mt_rand( $min, $max ) );
}

function getrandomstring( $_intSize )
{
	$__strString = "";
	srand( ( double )microtime( ) * 1000000 );
	$__arrRandomChar = array( "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z", "A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z" );
	$__i = 0;
	for ( ;	$__i < $_intSize;	++$__i	)
	{
		$__strString .= $__arrRandomChar[rand( 1, 61 )];
	}
	return $__strString;
}

function highlight_code( $str, $number = true, $show = false )
{
	if ( file_exists( $str ) )
	{
		$str = file_get_contents( $str );
	}
	$str = stripslashes( $str );
	$str = str_replace( array( "&lt;", "&gt;" ), array( "<", ">" ), $str );
	$str = str_replace( array( "&lt;?php", "?&gt;", "\\" ), array( "phptagopen", "phptagclose", "backslashtmp" ), $str );
	$str = "<?php //tempstart\n".$str."//tempend ?>";
	$str = highlight_string( $str, TRUE );
	if ( abs( phpversion( ) ) < 5 )
	{
		$str = str_replace( array( "<font ", "</font>" ), array( "<span ", "</span>" ), $str );
		$str = preg_replace( "#color=\"(.*?)\"#", "style=\"color: \\1\"", $str );
	}
	$str = preg_replace( "#\\<code\\>.+?//tempstart\\<br />\\</span\\>#is", "<code>\n", $str );
	$str = preg_replace( "#\\<code\\>.+?//tempstart\\<br />#is", "<code>\n", $str );
	$str = preg_replace( "#//tempend.+#is", "</span>\n</code>", $str );
	$str = str_replace( array( "phptagopen", "phptagclose", "backslashtmp" ), array( "&lt;?php", "?&gt;", "\\" ), $str );
	$line = explode( "<br />", rtrim( ltrim( $str, "<code>" ), "</code>" ) );
	$result = "<div class=\"code\"><ol>";
	foreach ( $line as $key => $val )
	{
		$result .= "<li>".$val."</li>";
	}
	$result .= "</ol></div>";
	if ( $show !== false )
	{
		echo $result;
	}
	return $result;
}

function f_int( $id )
{
	$id = intval( $id );
	if ( empty( $id ) )
	{
		exit( "非法的请求" );
	}
	return $id;
}

function getip( )
{
	if ( getenv( "HTTP_CLIENT_IP" ) && strcasecmp( getenv( "HTTP_CLIENT_IP" ), "unknown" ) )
	{
		$onlineip = getenv( "HTTP_CLIENT_IP" );
	}
	else if ( getenv( "HTTP_X_FORWARDED_FOR" ) && strcasecmp( getenv( "HTTP_X_FORWARDED_FOR" ), "unknown" ) )
	{
		$onlineip = getenv( "HTTP_X_FORWARDED_FOR" );
	}
	else if ( getenv( "REMOTE_ADDR" ) && strcasecmp( getenv( "REMOTE_ADDR" ), "unknown" ) )
	{
		$onlineip = getenv( "REMOTE_ADDR" );
	}
	else if ( isset( $_SERVER['REMOTE_ADDR'] ) && $_SERVER['REMOTE_ADDR'] && strcasecmp( $_SERVER['REMOTE_ADDR'], "unknown" ) )
	{
		$onlineip = $_SERVER['REMOTE_ADDR'];
	}
	$onlineip = preg_replace( "/^([d.]+).*/", "1", $onlineip );
	return $onlineip;
}

function url_router( )
{
	$path = strip_tags( $_SERVER['REQUEST_URI'] );
	$strpos = strpos( $path, ".php" );
	if ( $strpos )
	{
		$path = substr( $path, $strpos + 4 );
	}
	else if ( empty( $_SERVER['QUERY_STRING'] ) )
	{
		$strpos = strpos( $path, "?" );
		if ( $strpos )
		{
			$path = substr( $path, $strpos + 1 );
		}
		else
		{
			$path = "";
		}
	}
	else
	{
		$path = $_SERVER['QUERY_STRING'];
	}
	if ( $path[0] == "/" )
	{
		$path = substr( $path, 1 );
	}
	if ( !empty( $path ) )
	{
		$path = explode( "/", $path );
		$router['controller'] = $path[0];
		$router['action'] = !empty( $path[1] ) ? $path[1] : "index";
		$i = 2;
		for ( ;	$i < sizeof( $path );	$i += 2	)
		{
			$params[$path[$i]] = isset( $path[$i + 1] ) ? $path[$i + 1] : "";
		}
		$router['params'] = $params;
		return $router;
	}
	$router['controller'] = "index";
	$router['action'] = "index";
	$router['params'] = array( );
	return $router;
}

function unbbcode( $chars )
{
	global $db;
	$chars = str_replace( ">", "&gt;", $chars );
	$chars = str_replace( "<", "&lt;", $chars );
	$chars = str_replace( "[left]", "<div align=left>", $chars );
	$chars = str_replace( "[/left]", "</div>", $chars );
	$chars = str_replace( "[center]", "<div align=center>", $chars );
	$chars = str_replace( "[/center]", "</div>", $chars );
	$chars = str_replace( "[right]", "<div align=right>", $chars );
	$chars = str_replace( "[/right]", "</div>", $chars );
	$chars = str_replace( "<br />", "", $chars );
	$pattern = array( "/\\[b\\](.+?)\\[\\/b\\]/is", "/\\[i\\](.+?)\\[\\/i\\]/is", "/\\[u\\](.+?)\\[\\/u\\]/is", "/\\[font=([^\\[]*)\\](.+?)\\[\\/font\\]/is", "/\\[color=([#0-9a-z]{1,10})\\](.+?)\\[\\/color\\]/is", "/\\[size=([0-9]{1,2})\\](.+?)\\[\\/size\\]/is", "/\\[email=([^\\[]*)\\](.+?)\\[\\/email\\]/is", "/\\[email\\]([^\\[]*)\\[\\/email\\]/is", "/\\[url=([^\\[]*)\\](.+?)\\[\\/url\\]/is", "/\\[url\\]www\\.([^\\[]*)\\[\\/url\\]/is", "/\\[url\\]([^\\[]*)\\[\\/url\\]/is", "/\\[fly\\](.+?)\\[\\/fly\\]/is", "/\\[move\\](.+?)\\[\\/move\\]/is", "/\\[align=(left|center|right)\\](.+?)\\[\\/align\\]/is", "/\\[shadow=([#0-9a-z]{1,10})\\,([0-9]{1,3})\\,([0-9]{1,2})\\](.+?)\\[\\/shadow\\]/is", "/\\[glow=([#0-9a-z]{1,10})\\,([0-9]{1,2})\\](.+?)\\[\\/glow\\]/is", "/\\[quote\\](.+?)\\[\\/quote\\]/is", "/\\[code\\](.+?)\\[\\/code\\]/is", "/\\[list\\](.+?)\\[\\/list\\]/is", "/\\[list=([aA1iI])\\](.+?)\\[\\/list\\]/is", "/\\[\\*\\](.*?)/i" );
	$replacement = array( "<b>\\1</b>", "<i>\\1</i>", "<u>\\1</u>", "<font face=\"\\1\">\\2</font>", "<font color=\"\\1\">\\2</font>", "<font size=\"\\1\">\\2</font>", "<a href=\"mailto:\\1\">\\2</a>", "<a href=\"mailto:\\1\">\\1</a>", "<a href=\"\\1\" target=_blank>\\2</a>", "<a href=\"http://www.\\1\" target=_blank>\\1</a>", "<a href=\"\\1\" target=_blank>\\1</a>", "<marquee width=90% behavior=alternate scrollamount=3>\\1</marquee>", "<marquee scrollamount=3>\\1</marquee>", "<div align=\\1>\\2</div>", "<table width=*><tr><td style=\"filter:shadow(color=\\1, direction=\\2 ,strength=\\3)\">\\4</td></tr></table>", "<table width=*><tr><td style=\"filter:glow(color=\\1, strength=\\2)\">\\3</td></tr></table>", "<blockquote><b>引用:</b><hr><font face='Courier New'>\\1</font><hr></blockquote>", "<blockquote><b>代码:</b><hr><font face='Courier New'>\\1</font><hr></blockquote>", "<ul>\\1</ul>", "<ol type=\\1>\\2</ol>", "<li>\\1</li>" );
	$chars = preg_replace( $pattern, $replacement, $chars );
	$chars = preg_replace( "/\\[img\\]\\s*(\\S+?)\\s*\\[\\/img\\]/is", "<a href=\\1 target=_blank title=\"点击浏览图片\"><img src=\\1 border=0 onload=\"javascript:if(this.width>600)this.height=this.height*600/this.width;\"></a>", $chars );
	return $chars;
}

function smod( $text, $urlvalidate )
{
	$text2 = $text.$urlvalidate;
	$text3 = base64_encode( substr( md5( md5( substr( base64_encode( $text2 ), -3 ).substr( base64_encode( $text2 ), 1, 5 ) )."810413" ), 4, 13 ).md5( md5( substr( base64_encode( $text2 ), -3 ).substr( base64_encode( $text2 ), 1, 5 ) )."790416" ) );
	return $text3;
}

function surl( $surl1, $surl2, $surl3, $surl4, $surl5, $surlhost )
{
	if ( $surl1 != $surlhost && $surl2 != $surlhost && $surl3 != $surlhost && $surl4 != $surlhost && $surl5 != $surlhost )
	{

	}
}

function cache_id( $file )
{
	if ( empty( $_SERVER['QUERY_STRING'] ) )
	{
		$cache_id = $file;
		return $cache_id;
	}
	$cache_id = $file."?".$_SERVER['QUERY_STRING'];
	return $cache_id;
}

function smarray( $re1r, $list )
{
	$re1r = @array_map( "remove_slashs", $re1r );
	if ( !empty( $list ) )
	{
		$list_ = explode( "|", $list );
		foreach ( $list_ as $key )
		{
			$list__[$key] = $re1r[$key];
		}
		return $list__;
	}
}

function smarrayall( $re1r )
{
	$re1r = @array_map( "remove_slashs", $re1r );
	if ( !empty( $re1r ) )
	{
		foreach ( $re1r as $key => $value )
		{
			if ( !is_int( $key ) )
			{
				$list__[$key] = $re1r[$key];
			}
		}
		return $list__;
	}
}

function remove_slashs( $var )
{
	if ( is_array( $var ) )
	{
		return array_map( "remove_slashs", $var );
	}
	return stripslashes( $var );
}

$time = time( );
$urlvalidate = "zapple";
$surlhost = $_SERVER['HTTP_HOST'];
$surlhost = smod( $surlhost, $urlvalidate );
surl( $surl1, $surl2, $surl3, $surl4, $surl5, $surlhost );
?>
