<?php
/**
 * 前台客服中心页面主文件 * @copyright Copyright (c) 2007 - 2009 巨腾科技 (www.020jt.com)
 * @contact 电话：020-38399445、020-38399446 邮箱：service@020jt.com
 * @version v4.0 2007-06-10
 */
require_once('include/config.php'); // 调用配置文件
require_once('include/db_mysql.php'); // 调用数据库类
require_once('include/common.inc.php'); // 调用公共配置文件
require_once('include/smarty_no_con.php'); // 调用smarty文件
require_once('include/function.php'); // 调用基本函数库
require_once('include/page.class.php'); // 调用分页类

require_once('include/include_default.php');    // 调用默认固定标签
require_once('include/include_top.php');        // 调用头部标签
//require_once('include/include_about.php');      // 调用关于我们标签
require_once('include/include_ad.php');         // 调用广告标签
require_once('include/include_article.php');    // 调用文章标签
//require_once('include/include_case.php');       // 调用项目标签
//require_once('include/include_contact.php');    // 调用联系我们标签
//require_once('include/include_down.php');       // 调用下载标签
require_once('include/include_link.php');       // 调用友情链接标签
//require_once('include/include_news.php');       // 调用新闻标签
//require_once('include/include_person.php');     // 调用诚聘英才标签
//require_once('include/include_product.php');    // 调用产品标签
//require_once('include/include_resource.php');   // 调用资源标签
//require_once('include/include_service.php');    // 调用客户服务标签
//require_once('include/include_vote.php');       // 调用投票标签
//require_once('include/include_blog.php');       // 调用博客标签


/**
 +-------------------------------------------------------------------
 * 主体处理程序
 +-------------------------------------------------------------------
 */ 

$c_userid = $_COOKIE['c_userid'];
$smarty->assign('c_userid', $c_userid); // 登录id
$act = empty($_GET['act']) ? 'list' : $_GET['act'];

switch($act) {

	case 'list':

		if (!empty($c_userid)) {
			$re1s = $db->query("select * from {$prefix}_service_online where uid='$c_userid'  order by time desc limit 0, 20");
			while($re1r = $db->getarray($re1s)) {
				$re1r['year'] = date("Y", $re1r['time']);
				$re1r['mon']  = date("m", $re1r['time']);
				$re1r['mday'] = date("d", $re1r['time']);
				$service_online_list_array[] = smarrayall($re1r);
			}
			$smarty->assign('service_online_list', $service_online_list_array);
		}

		break;


	case 'onlinesave':

		$title   = $_POST['title']; // 简体标题
		$content = $_POST['content']; // 繁体标题
		$jumpurl = 'service_online.php'; // 跳转链接，默认返回
		if (empty($title) && empty($content)) {
			$message = '标题不能为空';
		} else {
			// - 插入数据表
			$_POST['time'] = time();
			$_POST['uid']  = $c_userid;
			$db->insert_list("{$prefix}_service_online", $_POST, '|title|content|time|uid');
			$message = '您的问题已经提交成功,正在返回!';
			$jumpurl = 'service_online.php'; // 跳转链接，默认返回
		}
		// 跳转
		$smarty->assign('message', $message); // 跳转消息
		$smarty->assign('jumpurl', $jumpurl); // 跳转url
		$smarty->assign('jumptime', 2); // 跳转时间
		$smarty->display('skins/'.$skins.'/'.$language.'_messjump.html');
		exit();

		break;

	case 'page':

		// - 安全检查
		$id = f_int($_GET['id']);

		// - 输出列表
		$re1s = $db->query("select * from {$prefix}_service_online where id = '$id'");
		$re1r = $db->getarray($re1s);
		$re1r['time'] = date("Y-m-d H:s" ,$re1r['time']);
		$viewlist = smarrayall($re1r);
		$smarty->assign('view', $viewlist); // 定义显示数组
		
		break;

}


/* ***********************************************************
* 调用模板文件
*********************************************************** */
$smarty->assign('act', $act);
$setuplist = smarrayall($setup);
$smarty->assign('setup', $setuplist); // 定义显示数组
$smarty->assign('ptime', ptime($time_start)); // 程序结束时间
$smarty->assign('c_userid', $c_userid); // Cookie userid
$smarty->assign('c_username', $c_username);  // Cookie username
// 调用相对应的模板文件，$skins是默认风格，$language是默认语言
$smarty->display('skins/'.$skins.'/'.$language.'_service_online.html');
?>